package jp.halfmoon.inaba.aiwolf.condition;

import java.util.ArrayList;

import jp.halfmoon.inaba.aiwolf.lib.WolfsidePattern;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;


/**
 * Ȅ\NX
 */
public final class RoleCondition extends AbstractCondition {


	/** G[WFgԍ */
	public int agentNo;

	/** E */
	public Role role;

	/** w肵EȊOł邱Ƃ\  */
	public boolean isRoleBesides = false;


	// LbVp

	public static final int AGENT_MAX = 15;

	private static RoleCondition wolfCondition[] = new RoleCondition[AGENT_MAX + 1];
	private static RoleCondition possessedCondition[] = new RoleCondition[AGENT_MAX + 1];
	private static RoleCondition notWolfCondition[] = new RoleCondition[AGENT_MAX + 1];
	private static RoleCondition notPossessedCondition[] = new RoleCondition[AGENT_MAX + 1];

	// LbVp


	private RoleCondition( int agentno, Role role ) {
		this.agentNo = agentno;
		this.role = role;
	}


	private RoleCondition( int agentno, Role role, boolean isRoleBesides) {
		this.agentNo = agentno;
		this.role = role;
		this.isRoleBesides = isRoleBesides;
	}


	@Override
	public boolean isMatch( WolfsidePattern pattern ) {

		// w肵Eւ̃}b`
		if( !isRoleBesides ){
			// w肵EɃ}b`
			switch( role ){
				case WEREWOLF:
					return pattern.isWolf(agentNo);
				case POSSESSED:
					return pattern.isPossessed(agentNo);
				default:
					//TODO ̑E͖Ή
					// TwcɊ܂܂邩{eTwcɓ󂪑݂邩H
					break;
			}
		}else{
			// w肵EȊOɃ}b`
			switch( role ){
				case WEREWOLF:
					return !pattern.isWolf(agentNo);
				case POSSESSED:
					return !pattern.isPossessed(agentNo);
				default:
					//TODO ̑E͖Ή
					// TwcɊ܂܂邩{eTwcɓ󂪑݂邩H
					break;
			}
		}

		return false;
	}


	@Override
	public ArrayList<Integer> getTargetAgentNo() {

		// G[WFgԍXgɂĕԂ
		ArrayList<Integer> ret = new ArrayList<Integer>();
		ret.add(agentNo);

		return ret;

	}


	/**
	 * u̖Ełv擾
	 * @param agentNo G[WFgԍ
	 * @param role E
	 * @return
	 */
	public static RoleCondition getRoleCondition( Agent agent, Role role ){
		return getRoleCondition( agent.getAgentIdx(), role );
	}


	/**
	 * u̖Ełv擾
	 * @param agentNo
	 * @param role
	 * @return
	 */
	public static RoleCondition getRoleCondition( int agentNo, Role role ){

		if( agentNo < 1 || agentNo > AGENT_MAX ){
			return new RoleCondition(agentNo, role);
		}

		switch( role ){
			case WEREWOLF:
				if( wolfCondition[agentNo] == null ){
					wolfCondition[agentNo] = new RoleCondition(agentNo, role);
				}
				return wolfCondition[agentNo];
			case POSSESSED:
				if( possessedCondition[agentNo] == null ){
					possessedCondition[agentNo] = new RoleCondition(agentNo, role);
				}
				return possessedCondition[agentNo];
			default:
				break;
		}

		return new RoleCondition(agentNo, role);

	}


	/**
	 * u̖EłȂv擾
	 * @param agent G[WFg
	 * @param role E
	 * @return
	 */
	public static RoleCondition getNotRoleCondition( Agent agent, Role role ){
		return getNotRoleCondition( agent.getAgentIdx(), role );
	}


	/**
	 * u̖EłȂv擾
	 * @param agentNo
	 * @param role
	 * @return
	 */
	public static RoleCondition getNotRoleCondition( int agentNo, Role role ){

		if( agentNo < 1 || agentNo > AGENT_MAX ){
			return new RoleCondition(agentNo, role, true);
		}

		switch( role ){
			case WEREWOLF:
				if( notWolfCondition[agentNo] == null ){
					notWolfCondition[agentNo] = new RoleCondition(agentNo, role, true);
				}
				return notWolfCondition[agentNo];
			case POSSESSED:
				if( notPossessedCondition[agentNo] == null ){
					notPossessedCondition[agentNo] = new RoleCondition(agentNo, role, true);
				}
				return notPossessedCondition[agentNo];
			default:
				break;
		}

		return new RoleCondition(agentNo, role, true);

	}


	public String toString(){
		if( isRoleBesides ){
			return new StringBuilder().append(agentNo).append(" is not ").append(role.toString()).toString();
		}
		return new StringBuilder().append(agentNo).append(" is ").append(role.toString()).toString();
	}

}
