package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.lib.WolfsidePattern;
import jp.halfmoon.inaba.aiwolf.strategyplayer.ReceivedGuess;


/**
 * ͌̕ʂ\NX
 */
public final class AnalysisOfGuess {


	/** Sp^[͌̕ */
	private List<InspectedWolfsidePattern> allPattern = new ArrayList<InspectedWolfsidePattern>();

	/** G[WFg̒P̘Tvf͌ */
	private List<InspectedWolfsidePattern> singleAgentWolfPattern = new ArrayList<InspectedWolfsidePattern>();

	/** G[WFg̒P̋lvf͌ */
	private List<InspectedWolfsidePattern> singleAgentPossessedPattern = new ArrayList<InspectedWolfsidePattern>();

	/** G[WFg̍łÓȘTp^[ idx=AgentNo */
	private ArrayList<InspectedWolfsidePattern> mostWolfPattern = new ArrayList<InspectedWolfsidePattern>();

	/** G[WFg̍łÓȋlp^[ idx=AgentNo */
	private ArrayList<InspectedWolfsidePattern> mostPossessedPattern = new ArrayList<InspectedWolfsidePattern>();

	/** ̘Twcp^[(Null΍) */
	private static final InspectedWolfsidePattern emptyWolfsidePattern = new InspectedWolfsidePattern(new WolfsidePattern(new ArrayList<Integer>(), new ArrayList<Integer>()), 0.0);


	//TODO ł̓f[^\݂̂ɂāAi[͏ʃW[łׂHNX̃pbP[Wړ(ReceivedGuesszQ)
	/**
	 * RXgN^
	 * @param patterns Twc̃p^[
	 * @param guessmanager 
	 */
	public AnalysisOfGuess(int agentNum, LinkedHashSet<WolfsidePattern> patterns, GuessManager guessManager) {

		// X̃G[WFgP̂ŘTWElW߂
		ArrayList<Double> singleWolfScore = new ArrayList<Double>();
		ArrayList<Double> singlePossessedScore = new ArrayList<Double>();
		// 1IWɂ邽0Ԃ̗vfɃ_~[ݒ
		singleWolfScore.add(null);
		singlePossessedScore.add(null);
		for(int i = 1; i <= agentNum; i++){
			// W̏
			double wolfScore = 1.0;
			double possessedScore = 1.0;

			// _~[p^[̍쐬
			ArrayList<Integer> singleAgent = new ArrayList<Integer>();
			singleAgent.add(i);
			ArrayList<Integer> blank = new ArrayList<Integer>();
			WolfsidePattern wolfPattern = new WolfsidePattern(singleAgent, blank);
			WolfsidePattern posPattern = new WolfsidePattern(blank, singleAgent);

			List<ReceivedGuess> singleGuesses = guessManager.getGuessForSingleAgent(i);
			// ̑
			for(ReceivedGuess rguess : singleGuesses ){
				// ̓p^[Tp^[ƃ}b`邩
				if( rguess.guess.condition.isMatch(wolfPattern) ){
					wolfScore *= Math.pow( rguess.guess.correlation, rguess.weight);
				}
				// ̓p^[lp^[ƃ}b`邩
				if( rguess.guess.condition.isMatch(posPattern) ){
					possessedScore *= Math.pow( rguess.guess.correlation, rguess.weight);
				}
			}

			// P̃p^[ƂċL
			singleWolfScore.add(wolfScore);
			singlePossessedScore.add(possessedScore);
			InspectedWolfsidePattern inspectedWolfPattern = new InspectedWolfsidePattern(wolfPattern, wolfScore);
			InspectedWolfsidePattern inspectedPosPattern = new InspectedWolfsidePattern(posPattern, possessedScore);
			inspectedWolfPattern.guesses = singleGuesses;
			inspectedPosPattern.guesses = singleGuesses;
			singleAgentWolfPattern.add( inspectedWolfPattern );
			singleAgentPossessedPattern.add( inspectedPosPattern );
		}

		// G[WFg̍łÓȃp^[o^
		for(int i = 0; i <= agentNum; i++){
			mostWolfPattern.add(emptyWolfsidePattern);
			mostPossessedPattern.add(emptyWolfsidePattern);
		}

		// Twcp^[̑
		Iterator<WolfsidePattern> iter = patterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// ̃p^[Ɋ֘A鐄
			//List<ReceivedGuess> guesses = new ArrayList<ReceivedGuess>();

			double score = 1.0;
			// eT̒P̌W̌vZ
			for( int wolfAgentNo : pattern.wolfAgentNo ){
				score *= singleWolfScore.get(wolfAgentNo);
			}
			// el̒P̌W̌vZ
			for( int posAgentNo : pattern.possessedAgentNo ){
				score *= singlePossessedScore.get(posAgentNo);
			}
			// ̑
			for(ReceivedGuess rguess : guessManager.getGuessForMultiAgent() ){
				// ̏Twcp^[ƃ}b`邩
				if( rguess.guess.condition.isMatch(pattern) ){
					// Twc̃XRA␳
					score *= Math.pow( rguess.guess.correlation, rguess.weight);

					// ̃p^[Ɋ֘A鐄L
					//guesses.add(rguess);
				}
			}
			// Twcp^[ɑ΂錟،ʂi[
			InspectedWolfsidePattern inspectedPattern = new InspectedWolfsidePattern(pattern, score);
			//inspectedPattern.guesses = guesses;

			addPattern(inspectedPattern);

			// eG[WFg̘T/lƂčłÓȃp^[𒀎vZ
			for( int wolfAgentNo : pattern.wolfAgentNo ){
				if( score > mostWolfPattern.get(wolfAgentNo).score ){
					mostWolfPattern.set(wolfAgentNo, inspectedPattern);
				}
			}
			for( int posAgentNo : pattern.possessedAgentNo ){
				if( score > mostPossessedPattern.get(posAgentNo).score ){
					mostPossessedPattern.set(posAgentNo, inspectedPattern);
				}
			}

		}


	}


	/**
	 * ،ʂ̋L
	 * @param pattern
	 */
	public void addPattern(InspectedWolfsidePattern pattern){

		// ،ʂ̋L
		allPattern.add(pattern);

	}


	/**
	 * ̘TwcɊւ镪͌ʂ擾
	 * @return w肵TwcɊւ镪͌
	 */
	public InspectedWolfsidePattern getPattern(WolfsidePattern pattern){

		// Twcp^[̑
		for( InspectedWolfsidePattern workpattern : allPattern ){
			// 񉻂ēꂩ`FbN
			if( pattern.toString().equals(workpattern.pattern.toString()) ){
				// w肳ꂽƓł΁A͌ʂԂ
				return workpattern;
			}
		}

		// Ȃꍇ
		return null;

	}


	//TODO \bhɂă_~[ԂdlNullԂdl݂ĂċCBꂷH
	/**
	 * łÓȘTwcɊւ镪͌ʂ擾
	 * @return łÓȘTwcɊւ镪͌(XRAꍇAԂ͕ۏ؂Ȃ)@score0̃_~[Ԃ
	 */
	public InspectedWolfsidePattern getMostValidPattern(){

		InspectedWolfsidePattern mostValidWolfsidePattern = emptyWolfsidePattern;
		double mostValidWolfScore = Double.NEGATIVE_INFINITY;

		// Twcp^[̑
		for( InspectedWolfsidePattern pattern : mostWolfPattern ){
			// őXRAłΐwcL
			if( pattern != null && pattern.score > mostValidWolfScore ){
				mostValidWolfsidePattern = pattern;
				mostValidWolfScore = pattern.score;
			}
		}

		return mostValidWolfsidePattern;

	}


	/**
	 * ̃G[WFgT̃p^[̂AłÓȘTwcɊւ镪͌ʂ擾
	 * @param agentNo G[WFgԍ
	 * @return łÓȘTwcɊւ镪͌(XRAꍇAłɓo^ꂽ)@score0̃_~[Ԃ
	 */
	public InspectedWolfsidePattern getMostValidWolfPattern(int agentNo){

		return mostWolfPattern.get(agentNo);

	}


	/**
	 * ̃G[WFgl̃p^[̂AłÓȘTwcɊւ镪͌ʂ擾
	 * @param agentNo G[WFgԍ
	 * @return łÓȘTwcɊւ镪͌(XRAꍇAłɓo^ꂽ)@score0̃_~[Ԃ
	 */
	public InspectedWolfsidePattern getMostValidPossessedPattern(int agentNo){

		return mostPossessedPattern.get(agentNo);

	}


	/**
	 * G[WFgP̂ɊւlT͌̕ʂ擾
	 * @param agentNo G[WFgԍ
	 * @return
	 */
	public InspectedWolfsidePattern getSingleWolfPattern(int agentNo){

		return singleAgentPossessedPattern.get(agentNo - 1);

	}


	/**
	 * G[WFgP̂Ɋւ鋶l͌̕ʂ擾
	 * @param agentNo G[WFgԍ
	 * @return
	 */
	public InspectedWolfsidePattern getSinglePossessedPattern(int agentNo){

		return singleAgentPossessedPattern.get(agentNo - 1);

	}


}
