package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;

import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;

import jp.halfmoon.inaba.aiwolf.condition.AndCondition;
import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;
import jp.halfmoon.inaba.aiwolf.lib.DayInfo;
import jp.halfmoon.inaba.aiwolf.lib.GuardRecent;


/**
 * uqvNX
 */
public final class FromGuardRecent extends AbstractGuessStrategy {

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {
		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();

		GameInfo gameInfo = args.agi.latestGameInfo;

		// ̂Ȃ̓`FbN
		for( DayInfo dayInfo : args.agi.dayInfoList ){
			if( dayInfo.day >= 2 && dayInfo.attackAgentNo == null ){

				// ̌qʒu̐
				if( gameInfo.getRole() == Role.BODYGUARD ){

					// GJ擾
					Integer guardedAgentNo = args.agi.selfGuardRecent.get(dayInfo.day - 1);

					// qݒ肵Ă
					if( guardedAgentNo != null ){
						// GJ悪T̉\iT̃P[X͏PȂ݂Ɣꍇ̂݁j
						Guess guess = new Guess();
						guess.condition = RoleCondition.getRoleCondition( guardedAgentNo, Role.WEREWOLF );
						guess.correlation = 0.30;
						guesses.add(guess);
					}

				}


				// q̑
				for( GuardRecent guardRecent : args.agi.getGuardRecentList() ){
					if( guardRecent.agentNo != gameInfo.getAgent().getAgentIdx() &&
					    guardRecent.execDay == dayInfo.day - 1 &&
					    guardRecent.isEnable() ){

						// l^̏ꍇAGJ悪T̉\iT̃P[X͏PȂ݂Ɣꍇ̂݁j
						RoleCondition bodyguardNotWolf = RoleCondition.getNotRoleCondition( guardRecent.agentNo, Role.WEREWOLF );
						RoleCondition bodyguardNotPos = RoleCondition.getNotRoleCondition( guardRecent.agentNo, Role.POSSESSED );
						RoleCondition guardedWolf = RoleCondition.getRoleCondition( guardRecent.targetAgentNo, Role.WEREWOLF );

						Guess guess = new Guess();
						guess.condition = new AndCondition().addCondition(bodyguardNotWolf).addCondition(bodyguardNotPos).addCondition(guardedWolf);
						guess.correlation = 0.30;
						guesses.add(guess);
					}
				}


			}
		}



		// XgԂ
		return guesses;
	}

}
