package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;

import jp.halfmoon.inaba.aiwolf.condition.AbstractCondition;
import jp.halfmoon.inaba.aiwolf.condition.AndCondition;
import jp.halfmoon.inaba.aiwolf.condition.OrCondition;
import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;
import jp.halfmoon.inaba.aiwolf.lib.AgentParameterItem;
import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.Judge;


/**
 * u藚vNX
 */
public final class JudgeRecent extends AbstractGuessStrategy {

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {
		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();

		List<Integer> seers = args.agi.getEnableCOAgentNo(Role.SEER);
		List<Integer> mediums = args.agi.getEnableCOAgentNo(Role.MEDIUM);

		// SĂ̐蔻藚mF
		for( Judge judge : args.agi.getSeerJudgeList() ){

			AbstractCondition agentWolf = RoleCondition.getRoleCondition( judge.agentNo, Role.WEREWOLF );
			AbstractCondition agentPossessed = RoleCondition.getRoleCondition( judge.agentNo, Role.POSSESSED );
			AbstractCondition targetWolf = RoleCondition.getRoleCondition( judge.targetAgentNo, Role.WEREWOLF );

			// Ȕł΃XLbv
			if( !judge.isEnable() ){
				continue;
			}

			// lԔ肩
			if( judge.result == Species.HUMAN){

				//TODO 甒ႢŜ̒Ɉ͂miSp^[̔ےjAƂǂH
				// TT̃p^[Zi͂j
				Guess guess = new Guess();
				guess.condition = new AndCondition().addCondition(agentWolf).addCondition(targetWolf);
				guess.correlation = args.agentParam.getParam(AgentParameterItem.DEVINE_RATE_WTOW_WHITE, 1.0);
				guesses.add(guess);

			}else{

				Guess guess;

				//TODO ñ`FbN
				// o悪ȊO
				if( args.agi.agentState[judge.targetAgentNo].comingOutRole == null ||
					(args.agi.agentState[judge.targetAgentNo].comingOutRole != Role.SEER && args.agi.agentState[judge.targetAgentNo].comingOutRole != Role.MEDIUM ) ){

					// T̃p^[𔖂i딚j
					guess = new Guess();
					guess.condition = new AndCondition().addCondition(agentPossessed).addCondition(targetWolf);
					guess.correlation = 0.85;
					guesses.add(guess);

					// TT̃p^[𔖂it͂j
					guess = new Guess();
					guess.condition = new AndCondition().addCondition(agentWolf).addCondition(targetWolf);
					guess.correlation = args.agentParam.getParam(AgentParameterItem.DEVINE_RATE_WTOW_BLACK, 1.0);;
					guesses.add(guess);
				}


				//TODO ̓΍R݁E슚݂Ȃ猩Ȃ悤ɂH
				// 荕o͔TŌ
				if( judge.talk.getDay() == 1 ){
					guess = new Guess();
					guess.condition = agentWolf;
					guess.correlation = 0.95;
					guesses.add(guess);
				}

			}

		}


		// SĂ̐CO҂mF
		List<Integer> attackedSeers = new ArrayList<Integer>();
		for( int seer : seers ){
			// ܂ꂽ肩
			if( args.agi.agentState[seer].causeofDeath == CauseOfDeath.ATTACKED ){
				attackedSeers.add(seer);
			}
		}

		// ܂ꂽ̔͐ƌ
		for( Judge judge : args.agi.getSeerJudgeList() ){
			// ܂ꂽ肩̔肩
			if( attackedSeers.indexOf(judge.agentNo) != -1){

				// Ȕł΃XLbv
				if( !judge.isEnable() ){
					continue;
				}

				// lԔ肩
				if( judge.result == Species.HUMAN){
					// 肢悪T̃p^[𔖂
					Guess guess = new Guess();
					guess.condition = RoleCondition.getRoleCondition(judge.targetAgentNo, Role.WEREWOLF);
					guess.correlation = 0.80;
					guesses.add(guess);
				}else{
					// 肢悪T̃p^[Z
					Guess guess = new Guess();
					guess.condition = RoleCondition.getRoleCondition(judge.targetAgentNo, Role.WEREWOLF);
					guess.correlation = 1.20;
					guesses.add(guess);
				}

			}
		}


//TODO 2016~jł͎gpȂBIɖ߂
//		// ̔萔`FbN
//		for( int seer : seers ){
//			if( !isValidSeerJudgeNum( seer, args ) ){
//				// UZ
//				AbstractCondition agentWolf = RoleCondition.getRoleCondition( seer, Role.WEREWOLF );
//				AbstractCondition agentPossessed = RoleCondition.getRoleCondition( seer, Role.POSSESSED );
//
//				Guess guess = new Guess();
//				guess.condition = new OrCondition().addCondition(agentWolf).addCondition(agentPossessed);
//				guess.correlation = 1.3;
//				guesses.add(guess);
//			}
//		}
//		// ̔萔`FbN
//		for( int medium : mediums ){
//			if( !isValidMediumJudgeNum( medium, args ) ){
//				// UZ
//				AbstractCondition agentWolf = RoleCondition.getRoleCondition( medium, Role.WEREWOLF );
//				AbstractCondition agentPossessed = RoleCondition.getRoleCondition( medium, Role.POSSESSED );
//
//				Guess guess = new Guess();
//				guess.condition = new OrCondition().addCondition(agentWolf).addCondition(agentPossessed);
//				guess.correlation = 1.3;
//				guesses.add(guess);
//			}
//		}

		//TODO ̑Ó`FbN



		// XgԂ
		return guesses;
	}


	/**
	 * ̔萔Ó
	 * @param agentNo
	 * @param args
	 * @return
	 */
	private boolean isValidSeerJudgeNum(int agentNo, GuessStrategyArgs args){

		// 萔
		int trueJudgeNum;
		if( args.agi.agentState[agentNo].causeofDeath == CauseOfDeath.ALIVE ){
			trueJudgeNum = args.agi.latestGameInfo.getDay();
		}else{
			trueJudgeNum = args.agi.agentState[agentNo].deathDay - 1;
		}

		// ݂̔萔JEg
		int judgeCount = 0;
		for( Judge judge : args.agi.getSeerJudgeList() ){
			if( judge.agentNo == agentNo ){
				judgeCount++;
			}
		}

		// 萔
		if( judgeCount > trueJudgeNum ){
			return false;
		}

		// 萔Ȃ
		if( judgeCount < trueJudgeNum ){

			Talk lastTalk = null;
			// ŐV̍Ō̔擾
			for( Talk talk : args.agi.latestGameInfo.getTalkList() ){
				if( talk.getAgent().getAgentIdx() == agentNo ){
					lastTalk = talk;
				}
			}

			// ŐV1łĂ邩
			if( lastTalk != null ){
				//   肪ȂP[XCO̕񍐒̂
				for( int i = args.agi.latestGameInfo.getTalkList().size() - 1; i >= 0 ; i-- ){
					Talk talk = args.agi.latestGameInfo.getTalkList().get(i);
					if( talk.getAgent().getAgentIdx() == agentNo ){

						// 
						Utterance utterance = new Utterance(talk.getContent());

						if( utterance.getTopic() == Topic.COMINGOUT ){
							// COŕ񍐒
							return true;
						}else if( utterance.getTopic() != Topic.DIVINED ){
							// COEʕ񍐈ȊO̔sĂ
							return false;
						}

					}
				}

				// O܂łCOĂ茋ʂȂ
				return false;

			}else{
				//   肪PȂ̂
				if( judgeCount != trueJudgeNum - 1 ){
					return false;
				}
			}

		}

		return true;

	}


	/**
	 * ̔萔Ó
	 * @param agentNo
	 * @param args
	 * @return
	 */
	private boolean isValidMediumJudgeNum(int agentNo, GuessStrategyArgs args){

		// 萔
		int trueJudgeNum;
		if( args.agi.agentState[agentNo].causeofDeath == CauseOfDeath.ALIVE ){
			trueJudgeNum = ( args.agi.latestGameInfo.getDay() < 2 ) ? 0 : (args.agi.latestGameInfo.getDay() - 1);
		}else{
			trueJudgeNum = args.agi.agentState[agentNo].deathDay - 2;
		}


		// ݂̔萔JEg
		int judgeCount = 0;
		for( Judge judge : args.agi.getMediumJudgeList() ){
			if( judge.agentNo == agentNo ){
				judgeCount++;
			}
		}

		// 萔
		if( judgeCount > trueJudgeNum ){
			return false;
		}

		// 萔Ȃ
		if( judgeCount < trueJudgeNum ){

			Talk lastTalk = null;
			// ŐV̍Ō̔擾
			for( Talk talk : args.agi.latestGameInfo.getTalkList() ){
				if( talk.getAgent().getAgentIdx() == agentNo ){
					lastTalk = talk;
				}
			}

			// ŐV1łĂ邩
			if( lastTalk != null ){
				//   肪ȂP[XCO̕񍐒̂
				for( int i = args.agi.latestGameInfo.getTalkList().size() - 1; i >= 0 ; i-- ){
					Talk talk = args.agi.latestGameInfo.getTalkList().get(i);
					if( talk.getAgent().getAgentIdx() == agentNo ){

						// 
						Utterance utterance = new Utterance(talk.getContent());

						if( utterance.getTopic() == Topic.COMINGOUT ){
							// COŕ񍐒
							return true;
						}else if( utterance.getTopic() != Topic.INQUESTED ){
							// COEʕ񍐈ȊO̔sĂ
							return false;
						}

					}
				}

				// O܂łCOĂ茋ʂȂ
				return false;

			}else{
				//   肪PȂ̂
				if( judgeCount != trueJudgeNum - 1 ){
					return false;
				}
			}

		}

		return true;

	}

}
