package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;

import jp.halfmoon.inaba.aiwolf.condition.OrCondition;
import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;
import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.Judge;

import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.data.Team;
import org.aiwolf.common.net.GameSetting;

/**
 * umCYvNX
 */
public final class Noise extends AbstractGuessStrategy {

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {

		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();

		//TODO sŕWグ̂Ȃ̂ŁAtOĂĈꊇŔf

		GameSetting gameSetting = args.agi.gameSetting;

		// SĂ̔mF
		for( int day = 0; day < args.agi.latestGameInfo.getDay(); day++ ){
			for( Talk talk : args.agi.getTalkList(day) ){

				double correlation = 1.0;

				// ̏ڍׂ̎擾
				Utterance utterance = args.agi.getUtterance(talk.getContent());

				switch( utterance.getTopic() ){
					case COMINGOUT:
						// COΏۂȊO
						if( utterance.getTarget().getAgentIdx() != talk.getAgent().getAgentIdx() ){
							correlation *= 1.5;
						}
						// PPȂ󋵂ł̐lOCO
						if( utterance.getRole().getTeam() != Team.VILLAGER ){
							int wolfSideNum = gameSetting.getRoleNum(Role.WEREWOLF) + gameSetting.getRoleNum(Role.POSSESSED);
							if( args.agi.dayInfoList.get(day).aliveAgentList.size() > wolfSideNum * 2 ){
								correlation *= 1.5;
							}
						}
						break;
					case VOTE:
						// Ώۂ݂Ȃ
						if( !args.agi.isValidAgentNo( utterance.getTarget().getAgentIdx() ) ){
							correlation *= 1.30;
							break;
						}
						// Ώۂ
						if( utterance.getTarget().getAgentIdx() == talk.getAgent().getAgentIdx() ){
							correlation *= 1.05;
						}
						// _őΏۂSĂ
						if( args.agi.getCauseOfDeath( utterance.getTarget().getAgentIdx(), talk.getDay() ) != CauseOfDeath.ALIVE  ){
							correlation *= 1.05;
						}
						break;
					case ESTIMATE:
						// Ώۂ݂Ȃ
						if( utterance.getTarget().getAgentIdx() < 1 || utterance.getTarget().getAgentIdx() > args.agi.gameSetting.getPlayerNum() ){
							correlation *= 1.30;
							break;
						}
						// Ώۂ
						if( utterance.getTarget().getAgentIdx() == talk.getAgent().getAgentIdx() ){
							correlation *= 1.05;
						}

						break;
					case DISAGREE:
						// ̈Ӗ͕s\
						correlation *= 1.02;

						break;
					case AGREE:
						// ̈Ӗ擾
						Utterance refutterance = args.agi.getMeanFromAgreeTalk( talk, 0 );

						// ̈Ӗ͕s\
						if( refutterance == null ){
							correlation *= 1.05;
						}else{
							switch( refutterance.getTopic() ){
								case ESTIMATE:
									// Ώۂ݂Ȃ
									if( !args.agi.isValidAgentNo( refutterance.getTarget().getAgentIdx() ) ){
										correlation *= 1.30;
										break;
									}
									// Ώۂ
									if( refutterance.getTarget().getAgentIdx() == talk.getAgent().getAgentIdx() ){
										correlation *= 1.05;
									}
									break;
								case VOTE:
									// Ώۂ݂Ȃ
									if( !args.agi.isValidAgentNo( refutterance.getTarget().getAgentIdx() ) ){
										correlation *= 1.30;
										break;
									}
									// Ώۂ
									if( refutterance.getTarget().getAgentIdx() == talk.getAgent().getAgentIdx() ){
										correlation *= 1.05;
									}
									// _őΏۂSĂ
									if( args.agi.getCauseOfDeath( refutterance.getTarget().getAgentIdx(), talk.getDay() ) != CauseOfDeath.ALIVE  ){
										correlation *= 1.05;
									}
									break;
								default:
									break;
							}
						}

						break;
					default:
						break;
				}

				// WɕωꍇAǉ
				if( Double.compare(correlation, 1.0) != 0 ){
					// ΏۂTor̃p^[Z
					RoleCondition wolfCondition = RoleCondition.getRoleCondition( talk.getAgent().getAgentIdx(), Role.WEREWOLF );
					RoleCondition posCondition = RoleCondition.getRoleCondition( talk.getAgent().getAgentIdx(), Role.POSSESSED );

					Guess guess = new Guess();
					guess.condition = new OrCondition().addCondition(wolfCondition).addCondition(posCondition);
					guess.correlation = correlation;
					guesses.add(guess);
				}

			}
		}


//TODO 2016~jł͎gpȂBIɖ߂
//		// SĂ̐蔻mF
//		for( Judge judge : args.agi.getSeerJudgeList() ){
//			// sȔo(COɔoȂ)
//			if( judge.talk.equals(judge.cancelTalk) ){
//				// ΏۂTor̃p^[Z
//				RoleCondition wolfCondition = RoleCondition.getRoleCondition( judge.agentNo, Role.WEREWOLF );
//				RoleCondition posCondition = RoleCondition.getRoleCondition( judge.agentNo, Role.POSSESSED );
//
//				Guess guess = new Guess();
//				guess.condition = new OrCondition().addCondition(wolfCondition).addCondition(posCondition);
//				guess.correlation = 2.0;
//				guesses.add(guess);
//			}
//		}
//
//
//		// SĂ̗씻mF
//		for( Judge judge : args.agi.getMediumJudgeList() ){
//			// sȔo(COɔoȂ)
//			if( judge.talk.equals(judge.cancelTalk) ){
//				// ΏۂTor̃p^[Z
//				RoleCondition wolfCondition = RoleCondition.getRoleCondition( judge.agentNo, Role.WEREWOLF );
//				RoleCondition posCondition = RoleCondition.getRoleCondition( judge.agentNo, Role.POSSESSED );
//
//				Guess guess = new Guess();
//				guess.condition = new OrCondition().addCondition(wolfCondition).addCondition(posCondition);
//				guess.correlation = 2.0;
//				guesses.add(guess);
//			}
//		}


		// XgԂ
		return guesses;
	}

}
