package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.condition.AbstractCondition;
import jp.halfmoon.inaba.aiwolf.condition.AndCondition;
import jp.halfmoon.inaba.aiwolf.condition.OrCondition;
import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;
import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;

import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Vote;

/**
 * u[vNX
 */
public final class VoteTarget extends AbstractGuessStrategy {

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {

		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();


		// SĂ̓[mF(񓊕[=1)
		for( int day = 1; day < args.agi.latestGameInfo.getDay(); day++ ){

			VoteAnalyzer analyzer = new VoteAnalyzer(args.agi.getVoteList(day));


			// CO҂̃Xg擾
			List<Integer> mediums = args.agi.getEnableCOAgentNo(Role.MEDIUM, day, 0);

			for( Vote vote : args.agi.getVoteList(day) ){

				// [̐vfƂĂ̏d(菇݂肾ƌyȂ)
				double weight = 1.0;

				// 퓊[҂̏ꍇA菇݂Ƃďd݂
				if( mediums.size() >= 2 && mediums.indexOf(vote.getTarget().getAgentIdx()) != -1 ){
					weight *= 0.5;
				}
				// 퓊[҂Ⴂ̏ꍇA菇݂Ƃďd݂
				if( args.agi.isReceiveWolfJudge(vote.getTarget().getAgentIdx(), day, 0) ){
					weight *= 0.5;
				}

				AbstractCondition agentWolf = RoleCondition.getRoleCondition( vote.getAgent().getAgentIdx(), Role.WEREWOLF );
				AbstractCondition agentPossessed = RoleCondition.getRoleCondition( vote.getAgent().getAgentIdx(), Role.POSSESSED );

				Guess guess;


				// [̓[ꍇlTŌ
				guess = new Guess();
				guess.condition = agentWolf;
				guess.correlation = Math.pow(0.98 + analyzer.getReceiveVoteCount(vote.getTarget()) * 0.01, weight);
				guesses.add(guess);


				//TODO ҐΉ
				// ̐ւ̓[͐lOŌ
				if( day < 3 ){
					Role CORole = args.agi.getCORole( vote.getTarget().getAgentIdx(), day+1, 0 );
					if( CORole == Role.SEER ){
						guess = new Guess();
						guess.condition = new OrCondition().addCondition(agentWolf).addCondition(agentPossessed);
						guess.correlation = 1.05;
						guesses.add(guess);
					}
				}


			}
		}

		// XgԂ
		return guesses;
	}

}
