package jp.halfmoon.inaba.aiwolf.lib;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.client.lib.TemplateTalkFactory.TalkType;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.data.Vote;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;


/**
 * Q[
 */
public final class AdvanceGameInfo {


	// ---- ȉAn̕ϐ ----

	/** Q[JnɎ󂯎GameSetting */
	public GameSetting gameSetting;

	/** ŐVGameInfo */
	public GameInfo latestGameInfo;

	/** OiSj */
	private List<List<Talk>> talkLists = new ArrayList<List<Talk>>();

	/** [OiSj */
	private List<List<Vote>> voteLists = new ArrayList<List<Vote>>();

	/** CÕXg(ECO) */
	public List<ComingOut> comingOutList = new ArrayList<ComingOut>();

	/** CÕXg(lOECO) */
	public List<ComingOut> wolfsideComingOutList = new ArrayList<ComingOut>();

	/** G[WFg̏ idx = AgentNo */
	public AgentState[] agentState;

	/** Ƃ̏̃Xg */
	public List<DayInfo> dayInfoList = new ArrayList<DayInfo>();

	/** ߋɉ͂i[}bv(p) key=talkContent value=utterance */
	public HashMap<String, Utterance> analysedUtteranceMap = new HashMap<String, Utterance>(32);

	/** xE */
	public Role fakeRole;


	// _Kw}iX̗\B^CI[o[΍łȂ팸ρj
	// S_irootj
	// @{x薳_
	// @@{ePL_

	/** S_̎_(VXeɂm̂) */
	public ViewpointInfo allViewSystemInfo;

	/** S_̎_(ߑł) */
	public ViewpointInfo allViewTrustInfo;

	/** _̎_(lƂ̎_ւ̎Q) */
	public ViewpointInfo selfViewInfo;

	/** ̎ۂ̖E̎_(󋶐l̂ݑΉ) */
	public ViewpointInfo selfRealRoleViewInfo;


	/** 蔻ꗗ */
	private List<Judge> seerJudgeList = new ArrayList<Judge>();

	/** 씻ꗗ */
	private List<Judge> mediumJudgeList = new ArrayList<Judge>();

	/** qꗗ */
	private List<GuardRecent> guardRecentList = new ArrayList<GuardRecent>();

	/** ̔\͂ɂ锻̃Xg(p) */
	public List<Judge> selfInspectList = new ArrayList<Judge>();

	/** ̔\͂ɂ锻̃Xg(p) */
	public List<Judge> selfInquestList = new ArrayList<Judge>();

	/** ̌q(p) key=s(=1) value=ΏۃG[WFgԍ */
	public HashMap<Integer, Integer> selfGuardRecent = new HashMap<Integer, Integer>();

	/** ̔\͌ʂ񍐂( p) */
	public int reportSelfResultCount;

	// ---- ȉAƂɃZbgn̕ϐ ----

	/** {̋^σG[WFg̃Xg */
	public List<Integer> talkedSuspicionAgentList = new ArrayList<Integer>();

	/** {̐MpσG[WFg̃Xg */
	public List<Integer> talkedTrustAgentList = new ArrayList<Integer>();

	// ---- ȉAn̕ϐ ----

	/** tXVŌĂ΂ꂽUpdate()̂ƂTrueɂ */
	private boolean isDayUpdate;

	/** bǂ܂œǂ񂾂(ǂݎn߂锭No) */
	private int readTalkListNum;


	/**
	 * RXgN^
	 */
	public AdvanceGameInfo(GameInfo gameInfo, GameSetting gameSetting){

//		long starttime = System.currentTimeMillis();

		// Q[ݒ̏
		this.gameSetting = gameSetting;

		// 󂯎gameInfoŐV̂̂Ƃĕۊǂ
		//latestGameInfo = gameInfo;

		// G[WFgԂ̏
		agentState = new AgentState[gameSetting.getPlayerNum() + 1];
		for( int i = 1; i <= gameSetting.getPlayerNum(); i++ ){
			agentState[i] = new AgentState(i);
		}

		// S_̏(VXeɂm̂)
		allViewSystemInfo = new ViewpointInfo(gameSetting);

		// S_̏(̋U񍐂O)
		allViewTrustInfo = new ViewpointInfo(allViewSystemInfo);
		allViewSystemInfo.addInclusionViewpoint(allViewTrustInfo);

		// _̏
		selfViewInfo = new ViewpointInfo(allViewTrustInfo);
		selfViewInfo.removeWolfsidePattern(gameInfo.getAgent().getAgentIdx());
		allViewTrustInfo.addInclusionViewpoint(selfViewInfo);

		// l_̏
		if( gameInfo.getRole() == Role.POSSESSED ){
			selfRealRoleViewInfo = new ViewpointInfo(allViewTrustInfo);
			selfRealRoleViewInfo.removeNotPossessedPattern(gameInfo.getAgent().getAgentIdx());
			allViewTrustInfo.addInclusionViewpoint(selfRealRoleViewInfo);
		}


		// xȄݒ
		switch( gameInfo.getRole() ){
			case WEREWOLF:
				// TɊx肪ΐAȂ60%ŐxBxEŏAx߂Ƃ͑lŏ㏑
				if( Math.random() < 0.6 ){
					fakeRole = Role.SEER;
				}else{
					fakeRole = Role.VILLAGER;
				}
				break;
			case POSSESSED:
				fakeRole = Role.SEER;
				break;
			default:
				fakeRole = null;
				break;
		}


//		long endtime = System.currentTimeMillis();
//
//		// fobObZ[W̏o
//		System.out.println("AdvanceGameInfo InitTime:" + (endtime - starttime));

	}


	/**
	 * ̍XV(AbstractVillagerpNXupdate()ĂяoɎs)
	 * @param gameInfo
	 */
	public void update(GameInfo gameInfo){

		// tύX`FbN
		boolean updateday = false;
		if( latestGameInfo == null || gameInfo.getDay() > latestGameInfo.getDay() ){
			updateday = true;
		}

		// 󂯎gameInfoŐV̂̂Ƃĕۊǂ
		latestGameInfo = gameInfo;

		// tύX̏
		if( updateday ){

			isDayUpdate = true;
			dayStart();

		}else{

			isDayUpdate = false;

			// O̍XV
			setTalkList( latestGameInfo.getDay(), latestGameInfo.getTalkList() );

			// CO󋵂̍XV
			setCOList();

			// bǂ܂œǂ񂾂(ǂݎn߂锭No)̍XV
			readTalkListNum = latestGameInfo.getTalkList().size();

		}


	}


	private void dayStart(){

		// Ōɓǂ񂾃Oԍ̃Zbg
		readTalkListNum = 0;

		// [ʂ̐ݒ
		if( latestGameInfo.getDay() >= 1 ){
			setVoteList( latestGameInfo.getDay() - 1, latestGameInfo.getVoteList() );
		}

		// ݂蔭̏
		if( latestGameInfo.getExecutedAgent() != null ){
			// ݂ꂽG[WFg̏ԍXV
			agentState[latestGameInfo.getExecutedAgent().getAgentIdx()].deathDay = latestGameInfo.getDay();
			agentState[latestGameInfo.getExecutedAgent().getAgentIdx()].causeofDeath = CauseOfDeath.EXECUTED;
		}

		// ݔ̏
		if( latestGameInfo.getAttackedAgent() != null ){
			// ܂ꂽG[WFg̏ԍXV
			agentState[latestGameInfo.getAttackedAgent().getAgentIdx()].deathDay = latestGameInfo.getDay();
			agentState[latestGameInfo.getAttackedAgent().getAgentIdx()].causeofDeath = CauseOfDeath.ATTACKED;

			// e_Aݐ悪T̃p^[(VXe)
			allViewSystemInfo.removeWolfPattern(latestGameInfo.getAttackedAgent().getAgentIdx());
		}

		//TODO ҐΉ
		// cT̃p^[i(G16̏ꍇAYR񔭐4ڈȍ~)(VXe)
		int maxWolfNum = ( latestGameInfo.getAliveAgentList().size() - 1 ) / 2;
		if( latestGameInfo.getDay() >= 4 ){
			allViewSystemInfo.removePatternFromWolfNum(Common.getAgentNo(latestGameInfo.getAliveAgentList()), 1, maxWolfNum);
		}

		// V̏ݒ肷
		DayInfo toDayInfo = new DayInfo( latestGameInfo );
		dayInfoList.add(toDayInfo);


		// {̋^ρEMpσG[WFg̃Xg
		talkedSuspicionAgentList = new ArrayList<Integer>();
		talkedTrustAgentList = new ArrayList<Integer>();


		// l̏
		if( latestGameInfo.getRole() == Role.BODYGUARD ){
			// Qڈȍ~AĂΌqL
			if( latestGameInfo.getDay() >= 2 &&
				latestGameInfo.getAliveAgentList().contains( latestGameInfo.getAgent() ) ){
				selfGuardRecent.put( latestGameInfo.getDay() - 1, latestGameInfo.getGuardedAgent().getAgentIdx() );
			}
		}

		// 肢t̏
		if( latestGameInfo.getRole() == Role.SEER ){
			// Pڈȍ~AĂΐ肢ʂL
			if( latestGameInfo.getDay() >= 1 &&
			    latestGameInfo.getAliveAgentList().contains( latestGameInfo.getAgent() ) ){

				Judge newJudge = new Judge( latestGameInfo.getAgent().getAgentIdx(),
				                            latestGameInfo.getDivineResult().getTarget().getAgentIdx(),
				                            latestGameInfo.getDivineResult().getResult(),
				                            null );

				selfInspectList.add(newJudge);
			}
		}

		// \҂̏
		if( latestGameInfo.getRole() == Role.MEDIUM ){
			// Qڈȍ~AĂΗ\ʂL
			if( latestGameInfo.getDay() >= 2 &&
			    latestGameInfo.getAliveAgentList().contains( latestGameInfo.getAgent() ) ){

				Judge newJudge = new Judge( latestGameInfo.getAgent().getAgentIdx(),
				                            latestGameInfo.getMediumResult().getTarget().getAgentIdx(),
				                            latestGameInfo.getMediumResult().getResult(),
				                            null );

				selfInquestList.add(newJudge);
			}
		}

	}


	/**
	 * ÕZbg
	 * @param day 
	 * @param talklist ̃Xg
	 */
	private void setTalkList(int day, List<Talk> talklist ){

		// w̑O܂ł̃O𖄂߂
		while( talkLists.size() < day ){
			talkLists.add(new ArrayList<Talk>());
		}

		// ̃OΒǉAΏ㏑
		if( talkLists.size() > day){
			talkLists.set(day, talklist);
		}else{
			talkLists.add(talklist);
		}

	}


	/**
	 * O̎擾
	 * @param day 
	 * @return
	 */
	public List<Talk> getTalkList(int day){

		// f[^݂ꍇ
		if( day >= 0 && day < talkLists.size() ){
			return talkLists.get(day);
		}

		// f[^݂Ȃꍇ
		return null;

	}


	/**
	 *
	 * @param day 
	 * @param talkid ID
	 * @return
	 */
	public Talk getTalk(int day, int talkid){

		List<Talk> talkList = getTalkList(day);

		// w̃O݂邩
		if( talkList != null ){
			// ݂邩
			if( talkid >= 0 && talkid < talkList.size() ){
				return talkList.get(talkid);
			}
		}

		return null;

	}


	/**
	 * [ÕZbg
	 * @param day [sꂽ(񓊕[1)
	 * @param votelist [ʂ̃Xg
	 */
	private void setVoteList( int day, List<Vote> votelist ){

		// w̑O܂ł̓[ʂ𖄂߂
		while( voteLists.size() < day - 1){
			voteLists.add(new ArrayList<Vote>());
		}

		// ̃OΒǉAΏ㏑
		if( voteLists.lastIndexOf(0) >= day){
			voteLists.set(day, votelist);
		}else{
			voteLists.add(votelist);
		}

	}


	/**
	 * [O̎擾
	 * @param day [sꂽ(񓊕[1)
	 * @return
	 */
	public List<Vote> getVoteList(int day){

		// f[^݂ꍇ
		if( day >= 0 && day < voteLists.size() ){
			return voteLists.get(day);
		}

		// f[^݂Ȃꍇ
		return null;
	}


	/**
	 * CO󋵂̍XV
	 */
	private void setCOList(){

		// COPtO
		boolean existCancel = false;

		int day = latestGameInfo.getDay();
		List<Talk> talkList = talkLists.get(day);

		// ̑
		for (int i = readTalkListNum; i < talkList.size(); i++) {
			Talk talk = (Talk)talkList.get(i);
			Utterance utterance = getUtterance(talk.getContent());
			switch (utterance.getTopic())
			{
				case COMINGOUT:	// CO
					int COAgentNo = talk.getAgent().getAgentIdx();
					Role CORole = utterance.getRole();
					switch(CORole.getTeam()){
						case VILLAGER:
							// COΏۂȊOȂ珈ɃXLbv
							if( !utterance.getTarget().equals(talk.getAgent()) ){
								break;
							}

							// CO̍XV
							if( updateCommingOut( COAgentNo, CORole, talk ) ){
								// COP񔭐tO𗧂Ă
								existCancel = true;
							}
							break;
						case WEREWOLF:
							// CO̍XV
							updateWolfSideCommingOut( COAgentNo, CORole, talk );
							break;
						default:
							break;
					}
					break;
				case DIVINED:	// 肢
					int seerAgentNo = talk.getAgent().getAgentIdx();
					int inspectedAgentNo = utterance.getTarget().getAgentIdx();
					Species inspectResult = utterance.getResult();
					Judge sjudge = new Judge(seerAgentNo, inspectedAgentNo, inspectResult, talk);

					// \CO҂肢ʂ𗎂ƂꍇA\ʂƂĈ
					if( agentState[seerAgentNo].comingOutRole == Role.MEDIUM ){
						// \̓o^
						addMediumJudge(sjudge, talk);
					}else{
						// CO̍XV
						if( updateCommingOut( seerAgentNo, Role.SEER, talk ) ){
							// COP񔭐tO𗧂Ă
							existCancel = true;
						}

						// 肢̓o^
						addSeerJudge(sjudge, talk);
					}

					break;
				case INQUESTED:	// \
					int mediumAgentNo = talk.getAgent().getAgentIdx();
					int inquestedAgentNo = utterance.getTarget().getAgentIdx();
					Species inquestedResult = utterance.getResult();
					Judge mjudge = new Judge(mediumAgentNo, inquestedAgentNo, inquestedResult, talk);


					// 肢CO҂\ʂ𗎂ƂꍇA肢ʂƂĈ
					if( agentState[mediumAgentNo].comingOutRole == Role.SEER ){
						// 肢̓o^
						addSeerJudge(mjudge, talk);
					}else{
						// CO̍XV
						if( updateCommingOut( mediumAgentNo, Role.MEDIUM, talk ) ){
							// COP񔭐tO𗧂Ă
							existCancel = true;
						}

						// \̓o^
						addMediumJudge(mjudge, talk);
					}

					break;
				case GUARDED:
					int bodyGuardAgentNo = talk.getAgent().getAgentIdx();
					int guardedAgentNo = utterance.getTarget().getAgentIdx();
					GuardRecent guardRecent = new GuardRecent(bodyGuardAgentNo, guardedAgentNo, talk);

					// CO̍XV
					if( updateCommingOut( guardedAgentNo, Role.BODYGUARD, talk ) ){
						// COP񔭐tO𗧂Ă
						existCancel = true;
					}

					int guardReportCount = 0;
					for( GuardRecent guard : guardRecentList ){
						if( guard.isEnable() && guard.agentNo == bodyGuardAgentNo ){
							guardReportCount++;
						}
					}

					// qs𐄑Č
					guardRecent.execDay = guardReportCount + 1;

					// qꗗɓo^
					guardRecentList.add(guardRecent);

					break;
				default:
					break;
			}
		}

		// COP񂪂ꍇ
		if( existCancel ){
			// _\z
			remakeViewInfo();
		}

	}


	/**
	 * 񍐍ς݂̖E񍐂𖳌ɂiCOP񎞂̏j
	 * @param agentNo G[WFgԍ
	 * @param cancelTalk Ps
	 */
	private void cancelRoleReport(int agentNo, Talk cancelTalk){

		// CȎ
		for( ComingOut co : comingOutList ){
			// w肵G[WFg̗LCO
			if( co.agentNo == agentNo && co.isEnable() ){
				// P񔭌ݒ肷
				co.cancelTalk = cancelTalk;
			}
		}

		// SĂ̐蔻藚mF
		for( Judge judge : getSeerJudgeList() ){
			// w肵G[WFg̗LȔ肩
			if( judge.agentNo == agentNo && judge.isEnable() ){
				// P񔭌ݒ肷
				judge.cancelTalk = cancelTalk;
			}
		}

		// SĂ̗씻藚mF
		for( Judge judge : getMediumJudgeList() ){
			// w肵G[WFg̗LȔ肩
			if( judge.agentNo == agentNo && judge.isEnable() ){
				// P񔭌ݒ肷
				judge.cancelTalk = cancelTalk;
			}
		}

		// SĂ̌qmF
		for( GuardRecent guard : getGuardRecentList() ){
			// w肵G[WFg̗LȌq
			if( guard.agentNo == agentNo && guard.isEnable() ){
				// P񔭌ݒ肷
				guard.cancelTalk = cancelTalk;
			}
		}

	}


	/**
	 * _\z
	 */
	private void remakeViewInfo(){

		// S_ߑłVXe_ɍ킹
		allViewTrustInfo.remakePattern(allViewSystemInfo);

		// e_AT̃p^[O
		selfViewInfo.removeWolfPattern(latestGameInfo.getAgent().getAgentIdx());
		if( selfRealRoleViewInfo != null ){
			selfRealRoleViewInfo.removeWolfPattern(latestGameInfo.getAgent().getAgentIdx());
			selfRealRoleViewInfo.removeNotWolfsidePattern(latestGameInfo.getAgent().getAgentIdx());
		}

		// CÕp^[i荞(ߑł)
		List<Integer> agents = getEnableCOAgentNo(Role.SEER);
		if( agents.size() > 1 ){
			allViewTrustInfo.removePatternFromUniqueRole(getEnableCOAgentNo(Role.SEER));
		}

		// CÕp^[i荞(ߑł)
		agents = getEnableCOAgentNo(Role.MEDIUM);
		if( agents.size() > 1 ){
			allViewTrustInfo.removePatternFromUniqueRole(getEnableCOAgentNo(Role.MEDIUM));
		}

		// CÕp^[i荞(ߑł)
		agents = getEnableCOAgentNo(Role.BODYGUARD);
		if( agents.size() > 1 ){
			allViewTrustInfo.removePatternFromUniqueRole(getEnableCOAgentNo(Role.BODYGUARD));
		}

		// 蔻肩̃p^[i荞
		for( Judge seerJudge : seerJudgeList ){
			if( seerJudge.isEnable() ){
				// 肢ʂ̃p^[i荞(ߑł)
				allViewTrustInfo.removePatternFromJudge( seerJudge.agentNo, seerJudge.targetAgentNo, seerJudge.result );
			}
		}

		// 씻肩̃p^[i荞
		for( Judge mediumJudge : mediumJudgeList ){
			if( mediumJudge.isEnable() ){
				// 肢ʂ̃p^[i荞(ߑł)
				allViewTrustInfo.removePatternFromJudge( mediumJudge.agentNo, mediumJudge.targetAgentNo, mediumJudge.result );
			}
		}

	}


	/**
	 * CO̍XV
	 * @param agentNo G[WFgԍ
	 * @param role COE
	 * @param commingOutTalkCO
	 * @return CO̓P񂪔
	 */
	private boolean updateCommingOut(int agentNo, Role role, Talk commingOutTalk){

		boolean existCancel = false;

		// COĂԂŁA̖ECO
		if( agentState[agentNo].comingOutRole != null && role != agentState[agentNo].comingOutRole ){
			// COP񔭐tO𗧂Ă
			existCancel = true;

			// 񍐍ς݂̖E(COE蓙)𖳌ɂ
			cancelRoleReport( agentNo, commingOutTalk );
		}

		// CȎ
		for( ComingOut co : comingOutList ){
			// COG[WFg̗LCO
			if( co.agentNo == agentNo && co.isEnable() ){
				if( co.role == role ){
					// ɓECOĂ  Ĕ
					return existCancel;
				}
			}
		}

		// VCOƂēo^
		comingOutList.add( new ComingOut(agentNo, role, commingOutTalk) );

		// G[WFgXV
		agentState[agentNo].comingOutRole = role;

		// CÕp^[i荞(ߑł)
		List<Integer> agents = getEnableCOAgentNo(role);
		if( gameSetting.getRoleNum(role) == 1 && agents.size() > 1 ){
			allViewTrustInfo.removePatternFromUniqueRole(agents);
		}

		// TODO ̃NX͎_pȂ̂xE̐ŝ͕sK؁BOŐ䂷
		// TxEi̐lTx玩͑xj
		if( latestGameInfo.getRole() == Role.WEREWOLF ){
			// COiCOςȂ疳ɕςȂj
			if( agentState[latestGameInfo.getAgent().getAgentIdx()].comingOutRole == null ){
				for( Integer wolfAgentNo : getWolfList() ){
					if( wolfAgentNo == agentNo && wolfAgentNo != latestGameInfo.getAgent().getAgentIdx() ){
						fakeRole = Role.VILLAGER;
					}
				}
			}

		}

		return existCancel;

	}


	/**
	 * CO̍XViTECOj
	 * @param agentNo G[WFgԍ
	 * @param role COE
	 * @param commingOutTalkCO
	 */
	private void updateWolfSideCommingOut(int agentNo, Role role, Talk commingOutTalk){

		// CȎ
		for( ComingOut co : wolfsideComingOutList ){
			// COG[WFg̗LCO
			if( co.agentNo == agentNo && co.isEnable() ){
				if( co.role == role ){
					// ɓECOĂ  Ĕ
					return;
				}
			}
		}

		// ÂCO̓LZɂ
		for( ComingOut co : wolfsideComingOutList ){
			if( co.agentNo == agentNo && co.isEnable() ){
				co.cancelTalk = commingOutTalk;
			}
		}

		// VCOƂēo^
		wolfsideComingOutList.add( new ComingOut(agentNo, role, commingOutTalk) );

	}


	/**
	 * CO҂̃Xg擾iLCÔ݁j
	 * @param role 擾CO҂̖E
	 * @return CO҂̃G[WFgԍ̃Xg
	 */
	public List<Integer> getEnableCOAgentNo(Role role) {

		List<Integer> ret = new ArrayList<Integer>();

		// CȎ
		for( ComingOut co : comingOutList ){
			// w肵ELCO
			if( co.role == role && co.isEnable() ){
				// ʃXgɒǉ
				ret.add(co.agentNo);
			}
		}

		return ret;
	}


	/**
	 * w莞_COE擾
	 * @param agentNo E擾G[WFg
	 * @param day (ȉ)
	 * @param talkID ID()
	 * @return w肳ꂽs钼OԂCOĂE
	 */
	public Role getCORole(int agentNo, int day, int talkID){

		Role ret = null;

		// CȎ
		for( ComingOut co : comingOutList ){
			if( co.agentNo == agentNo ){
				if( Common.compareTalkID(co.commingOutTalk.getDay(), co.commingOutTalk.getIdx(), day, talkID) == -1 ){
					ret = co.role;
				}else{
					break;
				}
			}
		}

		return ret;

	}


	/**
	 * CO҂̃Xg擾iw蔭̒O_ŗLCÔ݁j
	 * @param role 擾CO҂̖E
	 * @param day 
	 * @param talkid ID
	 * @return CO҂̃G[WFgԍ̃Xg
	 */
	public List<Integer> getEnableCOAgentNo(Role role, int day, int talkID) {

		List<Integer> ret = new ArrayList<Integer>();

		// CȎ
		for( ComingOut co : comingOutList ){
			// w肵ELCO
			if( co.role == role && co.isEnable(day, talkID) ){
				// ʃXgɒǉ
				ret.add(co.agentNo);
			}
		}

		return ret;
	}


	/**
	 * 肢̓o^
	 * @param judge 
	 * @param talk 蔭
	 */
	private void addSeerJudge(Judge judge, Talk talk){

		// ꗗɓo^
		seerJudgeList.add(judge);

		if( isValidAgentNo(judge.targetAgentNo) ){
			// 肢ʂ̃p^[i荞(ߑł)
			allViewTrustInfo.removePatternFromJudge( judge.agentNo, judge.targetAgentNo, judge.result );
		}else{
			judge.cancelTalk = talk;
		}

	}


	/**
	 * \̓o^
	 * @param judge 
	 * @param talk 蔭
	 */
	private void addMediumJudge(Judge judge, Talk talk){

		// ꗗɓo^
		mediumJudgeList.add(judge);

		if( isValidAgentNo(judge.targetAgentNo) &&
		    agentState[judge.targetAgentNo].causeofDeath == CauseOfDeath.EXECUTED ){
			// \ʂ̃p^[i荞(ߑł)
			allViewTrustInfo.removePatternFromJudge( judge.agentNo, judge.targetAgentNo, judge.result );
		}else{
			judge.cancelTalk = talk;
		}

	}


	/**
	 * 蔻̃Xg擾iȔ܂ށj
	 * @return
	 */
 	public List<Judge> getSeerJudgeList() {
		return seerJudgeList;
	}


	/**
	 * 씻̃Xg擾iȔ܂ށj
	 * @return
	 */
	public List<Judge> getMediumJudgeList() {
		return mediumJudgeList;
	}


	/**
	 * q̃Xg擾iȗ܂ށj
	 * @return
	 */
	public List<GuardRecent> getGuardRecentList() {
		return guardRecentList;
	}


	/**
	 * tXVŌĂ΂ꂽUpdate()
	 * @return
	 */
	public boolean isDayUpdate(){
		return isDayUpdate;
	}


	/**
	 * [\擾
	 * @param agentNo
	 * @return
	 */
	public Integer getSaidVoteAgent(int agentNo){

		GameInfo gameInfo = latestGameInfo;

		Integer ret = null;

		// ̑
		for( Talk talk : gameInfo.getTalkList() ){
			if( talk.getAgent().getAgentIdx() == agentNo ){
				Utterance utterance = getUtterance(talk.getContent());
				if( utterance.getTopic() == Topic.VOTE ){
					// [錾
					if( gameInfo.getAgentList().contains(utterance.getTarget()) ){
						ret = utterance.getTarget().getAgentIdx();
					}
				}else if( utterance.getTopic() == Topic.AGREE ){
					// ӂ̈Ӑ}[錾
					Utterance refutterance = getMeanFromAgreeTalk( talk, 0 );
					if( refutterance != null && gameInfo.getAgentList().contains(refutterance.getTarget()) ){
						ret = refutterance.getTarget().getAgentIdx();
					}
				}
			}
		}
		return ret;
	}


	/**
	 * /SԂ擾
	 * @param AgentNo
	 * @param day
	 * @return
	 */
	public CauseOfDeath getCauseOfDeath( int AgentNo, int day ){

		// w肳ꂽɎS  Ԃ
		if( agentState[AgentNo].deathDay != null && agentState[AgentNo].deathDay <= day ){
			return agentState[AgentNo].causeofDeath;
		}

		// w肳ꂽɐ  Ԃ
		return CauseOfDeath.ALIVE;

	}


	/**
	 * agreëӖ擾
	 * @param talk agree
	 * @return agreëӖ(͕s\AagreeȊOw莞null)
	 */
	public Utterance getMeanFromAgreeTalk( Talk talk, int depth ){

		Utterance utterance = getUtterance(talk.getContent());

		// ̔AGREEȊO
		if( utterance.getTopic() != Topic.AGREE ){
			return null;
		}

		// ̎ނ̃`FbN(sւ̓)
		if( utterance.getTalkType() == TalkType.WHISPER ){
			// ͕s\
			return null;
		}

		// ñ`FbN(݁`̔ւ̓)
		if( Common.compareTalkID( utterance.getTalkDay(), utterance.getTalkID(), talk.getDay(), talk.getIdx() ) >= 0 ){
			// ͕s\
			return null;
		}

		// QƐ̔̎擾
		Talk refTalk = getTalk( utterance.getTalkDay(), utterance.getTalkID() );

		// QƐ悪Ȃꍇ
		if( refTalk == null ){
			// ͕s\
			return null;
		}

		Utterance refutterance = getUtterance(refTalk.getContent());
		switch( refutterance.getTopic() ){
			case ESTIMATE:
				// QƐƓƉ߂
				return refutterance;
			case VOTE:
				// QƐƓƉ߂
				return refutterance;
			case AGREE:
				// QƂ[ΉsƂ
				if( depth >= 10 ){
					return null;
				}
				// XɎQƂAQƐƓƉ߂
				return getMeanFromAgreeTalk(refTalk, depth + 1);
			case DISAGREE:
				// Ӑ}sm̂ŁA͕s\Ƃ
				break;
			default:
				break;
		}

		// ͕s\
		return null;

	}


	/**
	 * wG[WFgw܂łɐ荕󂯂Ă邩
	 * @param agentNo G[WFgԍ
	 * @param day 
	 * @param talkID ID
	 * @return
	 */
	public boolean isReceiveWolfJudge( int agentNo, int day, int talkID ){

		for( Judge judge : getSeerJudgeList() ){
			// ñ`FbNi肪wOj
			if( Common.compareTalkID( judge.talk.getDay(), judge.talk.getIdx(), day, talkID) == -1 ){
				// Ώێ҂ւ̐lT肩
				if( judge.targetAgentNo == agentNo && judge.result == Species.WEREWOLF ){
					return true;
				}
			}
		}

		return false;

	}


	/**
	 * ŐVɎTalk̉񐔂擾
	 * @return ŐVɎTalk̉
	 */
	public int getMyTalkNum(){

		int count = 0;

		for( Talk talk : latestGameInfo.getTalkList() ){
			if( talk.getAgent().equals(latestGameInfo.getAgent()) ){
				count++;
			}
		}

		return count;

	}


	/**
	 * G[WFgԍ̑Ó`FbN
	 * @param agentno
	 * @return
	 */
	public boolean isValidAgentNo(int agentno){

		if( agentno <= 0 || agentno > gameSetting.getPlayerNum() ){
			return false;
		}

		return true;

	}


	/**
	 * ͓e̎擾iLbVpōj
	 * @param talkContent ̓e
	 * @return
	 */
	public Utterance getUtterance(String talkContent){

		Utterance ret;

		// ߋ͍̉ςݏɓo^ς
		if( analysedUtteranceMap.containsKey(talkContent) ){

			// ߋ͍̉ςݏ񂩂擾
			ret = analysedUtteranceMap.get(talkContent);

		}else{

			ret = new Utterance(talkContent);

			if( ret != null ){
				// ͍ςݏɓo^
				analysedUtteranceMap.put(talkContent, ret);
			}

		}

		return ret;

	}


	/**
	 * 肢ǉixpj
	 * @param judge
	 */
	public void addFakeSeerJudge(Judge judge){

		selfInspectList.add(judge);

	}


	/**
	 * w肵G[WFgTiT̎pj
	 * @param agentNo
	 * @return
	 */
	public boolean isWolf(int agentNo){

		GameInfo gameInfo = latestGameInfo;

		Role role = gameInfo.getRoleMap().get(Agent.getAgent(agentNo));

		if( role == Role.WEREWOLF ){
			return true;
		}

		return false;

	}


	/**
	 * T̈ꗗԂiT̎pj
	 * @return
	 */
	public List<Integer> getWolfList(){

		GameInfo gameInfo = latestGameInfo;

		List<Integer> ret = new ArrayList<Integer>();

		for( Agent agent : gameInfo.getAgentList() ){
			Role role = gameInfo.getRoleMap().get(agent);
			if( role == Role.WEREWOLF ){
				ret.add(agent.getAgentIdx());
			}
		}

		return ret;

	}


	/**
	 * ĂT̈ꗗԂiT̎pj
	 * @return
	 */
	public List<Integer> getAliveWolfList(){

		GameInfo gameInfo = latestGameInfo;

		List<Integer> ret = new ArrayList<Integer>();

		for( Agent agent : gameInfo.getAgentList() ){
			Role role = gameInfo.getRoleMap().get(agent);
			if( role == Role.WEREWOLF && agentState[agent.getAgentIdx()].causeofDeath == CauseOfDeath.ALIVE ){
				ret.add(agent.getAgentIdx());
			}
		}

		return ret;

	}


	/**
	 * PP\擾iT̎pj
	 * @return
	 */
	public boolean isEnablePowerPlay(){

		//TODO PPԂ΍PPU΍􂪕Kv
		//TODO ^̔A닶̔


		// c菈YT葽PP͔Ȃ
		if( Common.getRestExecuteCount(latestGameInfo.getAliveAgentList().size()) > getAliveWolfList().size() ){
			return false;
		}

		// l̃G[WFgԍ
		Integer possessed = null;

		// lT
		for( Judge judge : getSeerJudgeList() ){
			// lԂ̐肢tԈo
			if( !isWolf(judge.agentNo) &&
			    (judge.result == Species.WEREWOLF) != isWolf(judge.targetAgentNo) ){
				possessed = judge.agentNo;
			}
		}
		for( Judge judge : getMediumJudgeList() ){
			// lԂ̗\҂Ԉo
			if( !isWolf(judge.agentNo) &&
			    (judge.result == Species.WEREWOLF) != isWolf(judge.targetAgentNo) ){
				possessed = judge.agentNo;
			}
		}

		// l  l
		if( possessed != null && agentState[possessed].causeofDeath == CauseOfDeath.ALIVE ){
			// PP
			return true;
		}

		return false;

	}


	/**
	 * PP\擾il̎pj
	 * @return
	 */
	public boolean isEnablePowerPlay_Possessed(){

		// 3lȉȂmPP
		if( latestGameInfo.getAliveAgentList().size() <= 3 ){
			return true;
		}

		// ҂8lȉ
		if( latestGameInfo.getAliveAgentList().size() <= 8 ){
			// lOCOsl擾
			for( ComingOut co : wolfsideComingOutList ){
				// LCO  _Ŋmł͂Ȃ
				if( co.isEnable() && !selfRealRoleViewInfo.isFixWhite(co.agentNo) ){
					// PPƔf
					return true;
				}
			}
		}

		return false;

	}

}
