package jp.halfmoon.inaba.aiwolf.lib;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.List;

import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameSetting;


/**
 * _\NX
 */
public final class ViewpointInfo {

	/** ̎_ő݂ATwc̑gݍ킹p^[ */
	public LinkedHashSet<WolfsidePattern> wolfsidePatterns;

	/** ̎_܂鎋_ */
	public List<ViewpointInfo> inclusionViewpoint = new ArrayList<ViewpointInfo>();



	/** LbV񂪗L */
	private boolean isCacheEnable;


	/** T̃p^[݂ȂG[WFgꗗ */
	private List<Integer> notWolfAgentNo = new ArrayList<Integer>();

	/** T/T̃p^[݂G[WFgꗗ */
	private List<Integer> unclearWolfAgentNo = new ArrayList<Integer>();

	/** T̃p^[݂݂̂G[WFgꗗ */
	private List<Integer> fixWolfAgentNo = new ArrayList<Integer>();


	/** ̃p^[݂ȂG[WFgꗗ */
	private List<Integer> notPossessedAgentNo = new ArrayList<Integer>();

	/** /񋶂̃p^[݂G[WFgꗗ */
	private List<Integer> unclearPossessedAgentNo = new ArrayList<Integer>();

	/** ̃p^[݂݂̂G[WFgꗗ */
	private List<Integer> fixPossessedAgentNo = new ArrayList<Integer>();



	/** lÕp^[݂ȂG[WFgꗗ */
	private List<Integer> notWolfSideAgentNo = new ArrayList<Integer>();

	/** lO/lÕp^[݂G[WFgꗗ */
	private List<Integer> unclearWolfSideAgentNo = new ArrayList<Integer>();

	/** lÕp^[݂݂̂G[WFgꗗ */
	private List<Integer> fixWolfSideAgentNo = new ArrayList<Integer>();






	/**
	 * RXgN^
	 * @param gameSetting Q[ݒ
	 */
	public ViewpointInfo(GameSetting gameSetting){

		// S_̘Twcp^[쐬
		setWolfSidePattern(gameSetting);

		// p^[ɕύXo߁ALbV𖳌ɂ
		isCacheEnable = false;

	}


	/**
	 * RXgN^
	 * @param parent ̎_܂鎋_
	 */
	public ViewpointInfo(ViewpointInfo parent){

		// TwcRs[iTwc̎QƂRs[j
		wolfsidePatterns = new LinkedHashSet<WolfsidePattern>(parent.wolfsidePatterns.size() + 1, 1.0f);
		wolfsidePatterns.addAll(parent.wolfsidePatterns);

		// p^[ɕύXo߁ALbV𖳌ɂ
		isCacheEnable = false;

	}


	/**
	 * ̎_܂鎋_ǉ
	 * @param child
	 */
	public void addInclusionViewpoint(ViewpointInfo child){
		inclusionViewpoint.add(child);
	}


	/**
	 * _蒼ie_ɑj
	 * @param parent ̎_܂鎋_
	 */
	public void remakePattern(ViewpointInfo parent){

		// TwcRs[iTwc̎QƂRs[j@̈̍팸_āAV
		wolfsidePatterns = new LinkedHashSet<WolfsidePattern>(parent.wolfsidePatterns.size() + 1, 1.0f);
		wolfsidePatterns.addAll(parent.wolfsidePatterns);

		// p^[ɕύXo߁ALbV𖳌ɂ
		isCacheEnable = false;

 		// ܂鎋_A̎_ɍ蒼
		for( ViewpointInfo child : inclusionViewpoint ){
			child.remakePattern(this);
		}

	}


	//TODO ҐΉ
	/**
	 * S_̘Twc̑gݍ킹p^[ݒ肷
	 * @param gameSetting
	 */
 	private void setWolfSidePattern(GameSetting gameSetting){

 		LinkedHashSet<WolfsidePattern> patterns = new LinkedHashSet<WolfsidePattern>(5460, 1.0f);

		// QTP
		if( gameSetting.getRoleNum(Role.WEREWOLF) == 2 && gameSetting.getRoleNum(Role.POSSESSED) == 1 ){
			// TA
			for(int wolfAcnt=1; wolfAcnt <= gameSetting.getPlayerNum() - 2; wolfAcnt++){
				// TB
				for(int wolfBcnt = wolfAcnt + 1; wolfBcnt <= gameSetting.getPlayerNum() - 1; wolfBcnt++){

					ArrayList<Integer> wolves = new ArrayList<Integer>();
					wolves.add(wolfAcnt);
					wolves.add(wolfBcnt);

					// 
					for(int possessedcnt = 1; possessedcnt <= gameSetting.getPlayerNum(); possessedcnt++){
						if( possessedcnt != wolfAcnt && possessedcnt != wolfBcnt ){

							ArrayList<Integer> possessed = new ArrayList<Integer>();
							possessed.add(possessedcnt);

							WolfsidePattern pattern = new WolfsidePattern(wolves, possessed);
							patterns.add( pattern );
						}
					}
				}
			}
		}

		// RTP
		if( gameSetting.getRoleNum(Role.WEREWOLF) == 3 && gameSetting.getRoleNum(Role.POSSESSED) == 1 ){
			// TA
			for(int wolfAcnt=1; wolfAcnt <= gameSetting.getPlayerNum() - 2; wolfAcnt++){
				// TB
				for(int wolfBcnt = wolfAcnt + 1; wolfBcnt <= gameSetting.getPlayerNum() - 1; wolfBcnt++){
					// TC
					for(int wolfCcnt = wolfBcnt + 1; wolfCcnt <= gameSetting.getPlayerNum(); wolfCcnt++){

						ArrayList<Integer> wolves = new ArrayList<Integer>();
						wolves.add(wolfAcnt);
						wolves.add(wolfBcnt);
						wolves.add(wolfCcnt);

						// 
						for(int possessedcnt = 1; possessedcnt <= gameSetting.getPlayerNum(); possessedcnt++){
							if( possessedcnt != wolfAcnt && possessedcnt != wolfBcnt && possessedcnt != wolfCcnt ){

								ArrayList<Integer> possessed = new ArrayList<Integer>();
								possessed.add(possessedcnt);

								WolfsidePattern pattern = new WolfsidePattern(wolves, possessed);
								patterns.add( pattern );
							}
						}
					}
				}
			}
		}

		wolfsidePatterns = patterns;

	}


 	/**
 	 * ̘Twcp^[폜
 	 * @param pattern
 	 */
 	private void removePattern(WolfsidePattern pattern, Iterator<WolfsidePattern> iter){

 		// ܂鎋_Twc̃p^[폜
		for( ViewpointInfo child : inclusionViewpoint ){
			child.removePattern(pattern);
		}

 		// ̎_Twc̃p^[폜
		iter.remove();

		// p^[ɕύXo߁ALbV𖳌ɂ
		isCacheEnable = false;

 	}


 	/**
 	 * ̘Twcp^[폜
 	 * @param pattern
 	 */
 	private void removePattern(WolfsidePattern pattern){

 		// ̎_Twc̃p^[폜
		wolfsidePatterns.remove(pattern);

 		// ܂鎋_Twc̃p^[폜
		for( ViewpointInfo child : inclusionViewpoint ){
			child.removePattern(pattern);
		}

		// p^[ɕύXo߁ALbV𖳌ɂ
		isCacheEnable = false;

 	}


	/**
	 * ̃G[WFgT̃p^[폜
	 * @param agentNo
	 */
	public void removeWolfPattern(int agentNo){

		// Sp^[`FbN
		Iterator<WolfsidePattern> iter = wolfsidePatterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// wG[WFgT̃p^[ł΍폜
			if( pattern.isWolf(agentNo) ){
				removePattern(pattern, iter);
			}
		}

	}


	/**
	 * ̃G[WFgTwc̃p^[폜
	 * @param agentNo
	 */
	public void removeWolfsidePattern(int agentNo){

		// Sp^[`FbN
		Iterator<WolfsidePattern> iter = wolfsidePatterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// wG[WFgTwc̃p^[ł΍폜
			if( pattern.isWolfSide(agentNo) ){
				removePattern(pattern, iter);
			}
		}

	}


	/**
	 * ̃G[WFgl̃p^[ȊO폜
	 * @param agentNo
	 */
	public void removeNotPossessedPattern(int agentNo){

		// Sp^[`FbN
		Iterator<WolfsidePattern> iter = wolfsidePatterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// wG[WFgl̃p^[łȂ΍폜
			if( !pattern.isPossessed(agentNo) ){
				removePattern(pattern, iter);
			}
		}

	}


	/**
	 * ̃G[WFgTwcłȂp^[폜
	 * @param agentNo
	 */
	public void removeNotWolfsidePattern(int agentNo){

		// Sp^[`FbN
		Iterator<WolfsidePattern> iter = wolfsidePatterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// wG[WFgTwc̃p^[łȂ΍폜
			if( !pattern.isWolfSide(agentNo) ){
				removePattern(pattern, iter);
			}
		}

	}


	/**
	 * Pl݂ȂE̍i荞݁iwG[WFĝAO`PƂē󐮗j
	 * @param agentNo
	 */
	public void removePatternFromUniqueRole(List<Integer> agentNo){

		// Sp^[`FbN
		Iterator<WolfsidePattern> iter = wolfsidePatterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// wG[WFgɘTwcɊ܂܂Ȃ҂Qȏアp^[폜
			boolean flag = false;
			for( int agent : agentNo ){
				if( !pattern.isWolfSide(agent) ){
					if( flag == false ){
						flag = true;
					}else{
						removePattern(pattern, iter);
						break;
					}
				}
			}
		}

	}


	/**
	 * O[v̘Twclw肵A𖞂Ȃp^[폜
	 * @param agentNo O[ṽG[WFgԍꗗ
	 * @param minnum O[v̍ŏTwc
	 * @param maxnum O[v̍őTwc
	 */
	public void removePatternFromWolfSideNum(List<Integer> agentNo, int minnum, int maxnum){

		// Sp^[`FbN
		Iterator<WolfsidePattern> iter = wolfsidePatterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// wp^[̘TJEg
			int count = 0;
			for( int agent : agentNo ){
				if( pattern.isWolfSide(agent) ){
					count++;
				}
			}
			// w肳ꂽlOĂ΃p^[폜
			if( count < minnum || count > maxnum ){
				removePattern(pattern, iter);
			}
		}

	}


	/**
	 * O[v̘Tlw肵A𖞂Ȃp^[폜
	 * @param agentNo O[ṽG[WFgԍꗗ(\[ĝŕύXĂȂ)
	 * @param minnum O[v̍ŏT
	 * @param maxnum O[v̍őT
	 */
	public void removePatternFromWolfNum(List<Integer> agentNo, int minnum, int maxnum){

		// G[WFgԍꗗ\[g
		Collections.sort(agentNo);

		// Sp^[`FbN
		Iterator<WolfsidePattern> iter = wolfsidePatterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// wp^[̘TJEg
			int count = 0;
//			for( int agent : agentNo ){
//				if( pattern.isWolf(agent) ){
//					count++;
//				}
//			}
			List<Integer> wolves = pattern.wolfAgentNo;
			int listIdx = 0;
			int patternIdx = 0;
			int listVal;
			int patternVal;
			while( listIdx < agentNo.size() && patternIdx < wolves.size() ){
				listVal = agentNo.get(listIdx);
				patternVal = wolves.get(patternIdx);
				if( listVal < patternVal ){
					listIdx++;
				}else if( listVal > patternVal ){
					patternIdx++;
				}else{
					count++;
					listIdx++;
					patternIdx++;
				}
			}

			// w肳ꂽlOĂ΃p^[폜
			if( count < minnum || count > maxnum ){
				removePattern(pattern, iter);
			}
		}

	}


	/**
	 * 肩̃p^[i荞
	 * @param agentNo oNo
	 * @param targetno ΏۂNo
	 * @param result 茋
	 */
	public void removePatternFromJudge(int agentNo, int targetno, Species result){

		// Sp^[`FbN
		Iterator<WolfsidePattern> iter = wolfsidePatterns.iterator();
		while( iter.hasNext() ){
			WolfsidePattern pattern = iter.next();

			// o삪lÕp^[͑ΏۊO
			if( pattern.isWolfSide(agentNo) ){
				continue;
			}

			// 肩
			if( result == Species.WEREWOLF ){
				//   ΏۃG[WFgT̃p^[łȂ΍폜
				if( !pattern.isWolf(targetno) ){
					removePattern(pattern, iter);
				}
			}else{
				//   ΏۃG[WFgT̃p^[ł΍폜
				if( pattern.isWolf(targetno) ){
					removePattern(pattern, iter);
				}
			}

		}

	}


	/**
	 * _̃LbV쐬
	 */
	private void makeCache(){

		// EDËꗗNA
		notWolfAgentNo.clear();
		unclearWolfAgentNo.clear();
		fixWolfAgentNo.clear();

		//TODO ҐΉ
		int wolfCount[] = new int[15+1];
		int possessedCount[] = new int[15+1];

		// ePLTElƂĊ܂܂p^[̐JEg
		for( WolfsidePattern pattern : wolfsidePatterns ){
			for( int wolf : pattern.wolfAgentNo ){
				wolfCount[wolf]++;
			}
			for( int pos : pattern.possessedAgentNo ){
				possessedCount[pos]++;
			}
		}

		// p^[̐ɂĔEDËꗗɐU蕪
		for( int i = 1; i <= 15; i++ ){

			// Tn
			if( wolfCount[i] == 0 ){
				notWolfAgentNo.add(i);
			}else if( wolfCount[i] == wolfsidePatterns.size() ){
				fixWolfAgentNo.add(i);
			}else{
				unclearWolfAgentNo.add(i);
			}

			// ln
			if( possessedCount[i] == 0 ){
				notPossessedAgentNo.add(i);
			}else if( possessedCount[i] == wolfsidePatterns.size() ){
				fixPossessedAgentNo.add(i);
			}else{
				unclearPossessedAgentNo.add(i);
			}

			// lOn
			if( wolfCount[i] + possessedCount[i] == 0 ){
				notWolfSideAgentNo.add(i);
			}else if( wolfCount[i] + possessedCount[i] == wolfsidePatterns.size() ){
				fixWolfSideAgentNo.add(i);
			}else{
				unclearWolfSideAgentNo.add(i);
			}

		}

		// LbVLɂ
		isCacheEnable = true;

	}


	/**
	 * ̃G[WFgm荕擾
	 * @param agentNo
	 * @return
	 */
	public boolean isFixBlack(int agentNo){

		// LbV񂪗LłȂ΍쐬
		if( !isCacheEnable ){
			makeCache();
		}

		// m荕̃XgɊ܂܂Ίm荕
		if( fixWolfAgentNo.indexOf(agentNo) != -1 ){
			return true;
		}

		// m荕ł͂Ȃ
		return false;

	}


	/**
	 * ̃G[WFgm蔒擾
	 * @param agentNo
	 * @return
	 */
	public boolean isFixWhite(int agentNo){

		// LbV񂪗LłȂ΍쐬
		if( !isCacheEnable ){
			makeCache();
		}

		// m荕̃XgɊ܂܂Ίm荕
		if( notWolfAgentNo.indexOf(agentNo) != -1 ){
			return true;
		}

		// m荕ł͂Ȃ
		return false;

	}


	/**
	 * ̃G[WFgmlO擾
	 * @param agentNo
	 * @return
	 */
	public boolean isFixWolfSide(int agentNo){

		// LbV񂪗LłȂ΍쐬
		if( !isCacheEnable ){
			makeCache();
		}

		// mlÕXgɊ܂܂ΊmlO
		if( fixWolfSideAgentNo.indexOf(agentNo) != -1 ){
			return true;
		}

		// mlOł͂Ȃ
		return false;

	}


	/**
	 * m̃G[WFgꗗ擾
	 * @return
	 */
	public List<Integer> getFixBlackAgent(){

		// LbV񂪗LłȂ΍쐬
		if( !isCacheEnable ){
			makeCache();
		}

		return fixWolfAgentNo;

	}


	/**
	 * m̃G[WFgꗗ擾
	 * @return
	 */
	public List<Integer> getFixWhiteAgent(){

		// LbV񂪗LłȂ΍쐬
		if( !isCacheEnable ){
			makeCache();
		}

		return notWolfAgentNo;

	}

}
