package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.guess.InspectedWolfsidePattern;
import jp.halfmoon.inaba.aiwolf.lib.Judge;
import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;


/**
 * spu{pv
 */
public final class BasicGuard extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;



		List<Integer> seers = args.agi.getEnableCOAgentNo(Role.SEER);
		List<Integer> mediums = args.agi.getEnableCOAgentNo(Role.MEDIUM);

		// Up^[̍őXRAŏ̂̂߂
		double minScore = Double.MAX_VALUE;
		for( int seer : seers ){
			InspectedWolfsidePattern wolfPattern = args.aguess.getMostValidWolfPattern(seer);
			InspectedWolfsidePattern posPattern = args.aguess.getMostValidPossessedPattern(seer);

			double score = ( wolfPattern != null ? wolfPattern.score : 0.0 ) + ( posPattern != null ? posPattern.score : 0.0 );

			minScore = Math.min(score, minScore);
		}

		// UXRA̍傫Uł
		int falseCount = 0;
		for( int seer : seers ){
			InspectedWolfsidePattern wolfPattern = args.aguess.getMostValidWolfPattern(seer);
			InspectedWolfsidePattern posPattern = args.aguess.getMostValidPossessedPattern(seer);
			double score = ( wolfPattern != null ? wolfPattern.score : 0.0 ) + ( posPattern != null ? posPattern.score : 0.0 );

			if( score > minScore * 1.6 ){
				falseCount++;
			}
		}

		// PlċUł
		if( falseCount == seers.size() - 1 ){
			// ^ł̌q
			for( int seer : seers ){
				InspectedWolfsidePattern wolfPattern = args.aguess.getMostValidWolfPattern(seer);
				InspectedWolfsidePattern posPattern = args.aguess.getMostValidPossessedPattern(seer);

				double score = ( wolfPattern != null ? wolfPattern.score : 0.0 ) + ( posPattern != null ? posPattern.score : 0.0 );

				if( Double.compare(score, minScore) == 0 ){
					workReq = new Request(seer);
					workReq.guard = 3.0;
					Requests.add(workReq);
				}else{
					workReq = new Request(seer);
					workReq.guard = 0.5;
					Requests.add(workReq);
				}
			}
		}


		//TODO ҐΉE@œors݂p^[̑Ή(e莋_΁AD̑SɐFĂ邩Ŕf\)
		// dI͌qȂ
		for( int seer : seers ){
			// EEȊO̐FlOJEg
			int seerEnemyCnt = seers.size() - 1;
			int mediumEnemyCnt = ( mediums.size() > 1 ) ? (mediums.size() - 1) : 0;
			int hitGrayBlackCnt = 0;
			for( Judge judge : args.agi.getSeerJudgeList() ){
				if( judge.isEnable() &&
				    judge.agentNo == seer &&
				    judge.result == Species.WEREWOLF ){
					// 肪ȊO
					if( args.agi.agentState[judge.targetAgentNo].comingOutRole == null ||
						(args.agi.agentState[judge.targetAgentNo].comingOutRole != Role.SEER && args.agi.agentState[judge.targetAgentNo].comingOutRole != Role.MEDIUM ) ){
						hitGrayBlackCnt++;
					}
				}
			}

			if( seerEnemyCnt + mediumEnemyCnt + hitGrayBlackCnt >= 4 ){
				workReq = new Request(seer);
				workReq.guard = 0.001;
				Requests.add(workReq);
			}
		}


		// 肢tLpłȂΌqȂ
		for( Judge judge : args.agi.getSeerJudgeList() ){
			// 肢
			if( judge.agentNo == judge.targetAgentNo ){
				// qv
				workReq = new Request(judge.agentNo);
				workReq.guard = 0.5;
				Requests.add(workReq);
			}
		}


		// 錾ςݓ[͂̕擾
		VoteAnalyzer voteAnalyzer = VoteAnalyzer.loadSaidVote(args.agi);

		// Ă[ɉČq𔖂
		for( Agent agent : gameInfo.getAliveAgentList() ){
			workReq = new Request(agent);
			workReq.guard = Math.max( 1.00 - voteAnalyzer.getReceiveVoteCount(agent) * 0.03, 0.0 );
			Requests.add(workReq);
		}

		// ő[𓾂ĂG[WFg͌q悩珜O
		for( Agent agent : voteAnalyzer.getMaxReceiveVoteAgent() ){
			workReq = new Request(agent);
			workReq.guard = 0.01;
			Requests.add(workReq);
		}

		return Requests;
	}

}
