package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;

import org.aiwolf.common.data.Role;

import jp.halfmoon.inaba.aiwolf.guess.InspectedWolfsidePattern;


/**
 * spu̍sv
 */
public final class FromGuess extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;


		// P̍l@Ɛwcl@̏d݂߂iՂ͔XxŁAIՂ͂قڐwcl@݂̂ɂj
		double singleScoreWeight = Math.min( 0.1, 0.5 - args.agi.latestGameInfo.getDay() * 0.1 );
		double teamScoreWeight = Math.max( 0.9, 0.5 + args.agi.latestGameInfo.getDay() * 0.1 );


		// eG[WFg P/wcő  T/l XRAɉėvς
		for( int i = 1; i <= args.agi.gameSetting.getPlayerNum(); i++ ){

			// P̘Tp^[擾
			InspectedWolfsidePattern singleWolfPattern = args.aguess.getSingleWolfPattern(i);
			// TƂčłÓȃp^[擾
			InspectedWolfsidePattern mostWolfPattern = args.aguess.getMostValidWolfPattern(i);

			if( mostWolfPattern != null ){
				// T̉\
				workReq = new Request( i );
				workReq.vote = Math.pow(singleWolfPattern.score, singleScoreWeight) * Math.pow(mostWolfPattern.score, teamScoreWeight) + 0.0001;
				workReq.inspect = Math.pow( workReq.vote, 0.4 );
				workReq.guard = 1 / workReq.vote;

				// sv̓o^
				Requests.add(workReq);

			}else{

				// P̋lp^[擾
				InspectedWolfsidePattern singlePosPattern = args.aguess.getSinglePossessedPattern(i);
				// lƂčłÓȃp^[擾
				InspectedWolfsidePattern mostPosPattern = args.aguess.getMostValidPossessedPattern(i);

				if( mostPosPattern != null ){
					// mTAl̉\͂

					// ȊO
					if( args.agi.agentState[i].comingOutRole == null ||
						(args.agi.agentState[i].comingOutRole != Role.SEER && args.agi.agentState[i].comingOutRole != Role.MEDIUM ) ){
						workReq = new Request( i );
						workReq.vote = Math.pow(singlePosPattern.score, singleScoreWeight) * Math.pow(mostPosPattern.score, teamScoreWeight) * 0.4 + 0.0001;
						workReq.guard = 1 / workReq.vote;
						workReq.inspect = 0.0001;
					}else{
						workReq = new Request( i );
						workReq.vote = Math.pow(singlePosPattern.score, singleScoreWeight) * Math.pow(mostPosPattern.score, teamScoreWeight) * 0.8 + 0.0001;
						workReq.guard = 1 / workReq.vote;
						workReq.inspect = 0.0001;
					}

					// sv̓o^
					Requests.add(workReq);

				}else{
					// m葺
					workReq = new Request( i );
					workReq.vote = 0.01;
					workReq.guard = 1.2;
					workReq.inspect = 0.0001;

					// sv̓o^
					Requests.add(workReq);
				}
			}
		}


		// _Ŋm荕ǂ
		for( int i = 1; i <= args.agi.gameSetting.getPlayerNum(); i++ ){
			if( args.agi.selfViewInfo.isFixBlack(i) ){
				// _ŊmT
				workReq = new Request( i );
				workReq.vote = 1.5;
				workReq.guard = 0.0001;
				workReq.inspect = 0.0001;
			}else if( args.agi.selfViewInfo.isFixWolfSide(i) ){
				// _ŊmlO
				workReq = new Request( i );
				workReq.vote = 1.2;
				workReq.guard = 0.0001;
				workReq.inspect = 0.0001;
			}
		}


//
//		// łÓȘTwc擾
//		WolfsidePattern pattern = args.aguess.getMostValidPattern().pattern;
//
//
//		// łÓȘTwc̐T
//		int aliveWolfNum = 0;
//
//		// łÓȘTwc̘T
//		for( int wolfAgentNo : pattern.wolfAgentNo ){
//
//			if( args.agi.agentState[wolfAgentNo].causeofDeath == CauseOfDeath.ALIVE ){
//				aliveWolfNum++;
//
//				workReq = new Request( wolfAgentNo );
//				workReq.vote = 1.1;
//				workReq.guard = 1 / workReq.vote;
//
//				// sv̓o^
//				Requests.add(workReq);
//			}
//
//		}
//
//		// łÓȘTwc̋l
//		for( int posAgentNo : pattern.possessedAgentNo ){
//
//			workReq = new Request( posAgentNo );
//			// ]TOȂ狶l͕uiRPP˓ρj
//			if( Common.getRestExecuteCount( gameInfo.getAliveAgentList().size() ) > aliveWolfNum ){
//				workReq.vote = 1.05;
//			}
//			workReq.guard = 1 / workReq.vote;
//
//			// sv̓o^
//			Requests.add(workReq);
//
//		}




		return Requests;

	}

}
