package jp.halfmoon.inaba.aiwolf.strategyplayer;

import java.util.ArrayList;

import jp.halfmoon.inaba.aiwolf.guess.AnalysisOfGuess;
import jp.halfmoon.inaba.aiwolf.guess.COTiming;
import jp.halfmoon.inaba.aiwolf.guess.Favor;
import jp.halfmoon.inaba.aiwolf.guess.FirstImpression;
import jp.halfmoon.inaba.aiwolf.guess.Formation_Basic;
import jp.halfmoon.inaba.aiwolf.guess.FromGuardRecent;
import jp.halfmoon.inaba.aiwolf.guess.Guess;
import jp.halfmoon.inaba.aiwolf.guess.GuessManager;
import jp.halfmoon.inaba.aiwolf.guess.GuessStrategyArgs;
import jp.halfmoon.inaba.aiwolf.guess.InspectedWolfsidePattern;
import jp.halfmoon.inaba.aiwolf.guess.JudgeRecent;
import jp.halfmoon.inaba.aiwolf.guess.Noise;
import jp.halfmoon.inaba.aiwolf.guess.VoteRecent;
import jp.halfmoon.inaba.aiwolf.guess.VoteTarget;
import jp.halfmoon.inaba.aiwolf.learn.LearnData;
import jp.halfmoon.inaba.aiwolf.lib.AdvanceGameInfo;
import jp.halfmoon.inaba.aiwolf.lib.AgentParameter;
import jp.halfmoon.inaba.aiwolf.lib.AgentParameterItem;
import jp.halfmoon.inaba.aiwolf.lib.WolfsidePattern;
import jp.halfmoon.inaba.aiwolf.request.ActionStrategyArgs;
import jp.halfmoon.inaba.aiwolf.request.AnalysisOfRequest;
import jp.halfmoon.inaba.aiwolf.request.AttackObstacle;
import jp.halfmoon.inaba.aiwolf.request.BasicAttack;
import jp.halfmoon.inaba.aiwolf.request.BasicGuard;
import jp.halfmoon.inaba.aiwolf.request.BasicSeer;
import jp.halfmoon.inaba.aiwolf.request.FixInfo;
import jp.halfmoon.inaba.aiwolf.request.FromGuess;
import jp.halfmoon.inaba.aiwolf.request.PowerPlay_Possessed;
import jp.halfmoon.inaba.aiwolf.request.PowerPlay_Werewolf;
import jp.halfmoon.inaba.aiwolf.request.Request;
import jp.halfmoon.inaba.aiwolf.request.ReticentExecute;
import jp.halfmoon.inaba.aiwolf.request.RoleWeight;
import jp.halfmoon.inaba.aiwolf.request.RoleWeight_Wolfside;
import jp.halfmoon.inaba.aiwolf.request.VoteStack;

import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Team;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

/**
 * SĂ̖Ẽx[XƂȂNX
 */
public abstract class AbstractBaseStrategyPlayer extends AbstractRole{

	/** gQ[ */
	protected AdvanceGameInfo agi;

	/** sݒ肷邽߂̋[UI */
	protected ActionUI actionUI = new ActionUI();

	/** [悤ƎvĂvC[ */
	protected Integer planningVoteAgent;

	/** Ōɐ錾u[悤ƎvĂvC[v */
	protected Integer declaredPlanningVoteAgent;

	/** Ōɍs */
	protected AnalysisOfGuess latestGuess;

	/** Ōɍssv */
	protected AnalysisOfRequest latestRequest;

	/** 錾ς݂xE */
	protected Role declaredFakeRole;

	/** Ōɐ錾uP悤ƎvĂvC[v */
	protected Integer declaredPlanningAttackAgent;

	/** COς */
	protected boolean isCameOut;


	/** l̎Ă */
	protected AgentParameter agentParam = new AgentParameter();

	/** ۗL鐄헪 */
	protected ArrayList<HasGuessStrategy> guessStrategys = new ArrayList<HasGuessStrategy>();

	/** ۗLs헪 */
	protected ArrayList<HasActionStrategy> actionStrategys = new ArrayList<HasActionStrategy>();


	// @\

	/** ro߂o͂邩 */
	protected final boolean isPrintPassageTalk = false;

	/** Iʂo͂邩 */
	protected final boolean isPrintFinishTalk = false;

	/** wKp̃f[^o͂邩 */
	protected final boolean isPutLearnData = false;



	// fobOp

	/** Update()ɂԂ̂Œ̂́ifobOpj */
	protected long MaxUpdateTime = Long.MIN_VALUE;

	/** Update()ɂԂŒ̃^C~OifobOpj */
	protected String MaxUpdateTiming;


	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);

		// o
		planningVoteAgent = null;
		declaredPlanningVoteAgent = null;
		declaredFakeRole = null;
		declaredPlanningAttackAgent = null;
		isCameOut = false;
		guessStrategys = new ArrayList<HasGuessStrategy>();
		actionStrategys = new ArrayList<HasActionStrategy>();
		agentParam = new AgentParameter();


		// gQ[̏
		agi = new AdvanceGameInfo(gameInfo, gameSetting);


		// l̎Ă
		agentParam.setParam(AgentParameterItem.FAVOR_RATE, 0.06, true);
		agentParam.setParam(AgentParameterItem.VOTE_RATE_WTOW, 0.8, true);

		agentParam.setParam(AgentParameterItem.DEVINE_RATE_WTOW_WHITE, 1.05, true);
		agentParam.setParam(AgentParameterItem.DEVINE_RATE_WTOW_BLACK, 0.8, true);


		// 헪ݒ
		HasGuessStrategy guessStrategy;

		guessStrategy = new HasGuessStrategy(new FirstImpression(), 1.0);
		guessStrategys.add(guessStrategy);
		guessStrategy = new HasGuessStrategy(new FromGuardRecent(), 1.0);
		guessStrategys.add(guessStrategy);
		guessStrategy = new HasGuessStrategy(new Formation_Basic(), 1.0);
		guessStrategys.add(guessStrategy);
		guessStrategy = new HasGuessStrategy(new COTiming(), 1.0);
		guessStrategys.add(guessStrategy);
		//guessStrategy = new HasGuessStrategy(new AttackObstacle_Guess(), 1.0);
		//guessStrategys.add(guessStrategy);
		guessStrategy = new HasGuessStrategy(new JudgeRecent(), 1.0);
		guessStrategys.add(guessStrategy);

		// wcł̂ݗp鐄
		if( gameInfo.getRole().getTeam() == Team.VILLAGER ){
			guessStrategy = new HasGuessStrategy(new Noise(), 1.0);
			guessStrategys.add(guessStrategy);
			guessStrategy = new HasGuessStrategy(new VoteRecent(), 1.0);
			guessStrategys.add(guessStrategy);
			guessStrategy = new HasGuessStrategy(new VoteTarget(), 1.0);
			guessStrategys.add(guessStrategy);
		}

		// Twcł̂ݗp鐄
		if( gameInfo.getRole().getTeam() == Team.WEREWOLF ){
			guessStrategy = new HasGuessStrategy(new Noise(), 0.5);
			guessStrategys.add(guessStrategy);
			guessStrategy = new HasGuessStrategy(new VoteRecent(), 0.5);
			guessStrategys.add(guessStrategy);
		}

		// Tł̂ݗp鐄
		if( gameInfo.getRole() == Role.WEREWOLF ){
			guessStrategy = new HasGuessStrategy(new Favor(), 1.0);
			guessStrategys.add(guessStrategy);
		}


		// s헪ݒ
		HasActionStrategy actStrategy;
		actStrategy = new HasActionStrategy(new FixInfo(), 1.0);
		actionStrategys.add(actStrategy);
		actStrategy = new HasActionStrategy(new FromGuess(), 1.0);
		actionStrategys.add(actStrategy);

		// wcł̂ݗps
		if( gameInfo.getRole().getTeam() == Team.VILLAGER ){
			actStrategy = new HasActionStrategy(new RoleWeight(), 1.0);
			actionStrategys.add(actStrategy);
			actStrategy = new HasActionStrategy(new VoteStack(), 1.0);
			actionStrategys.add(actStrategy);
			actStrategy = new HasActionStrategy(new ReticentExecute(), 1.0);
			actionStrategys.add(actStrategy);
		}

		// ł̂ݗps
		if( gameInfo.getRole() == Role.SEER ){
			actStrategy = new HasActionStrategy(new BasicSeer(), 1.0);
			actionStrategys.add(actStrategy);
		}

		// ł̂ݗps
		if( gameInfo.getRole() == Role.BODYGUARD ){
			actStrategy = new HasActionStrategy(new BasicGuard(), 1.0);
			actionStrategys.add(actStrategy);
		}


		// Twcł̂ݗps
		if( gameInfo.getRole().getTeam() == Team.WEREWOLF ){
			actStrategy = new HasActionStrategy(new RoleWeight_Wolfside(), 1.0);
			actionStrategys.add(actStrategy);
			actStrategy = new HasActionStrategy(new BasicAttack(), 1.0);
			actionStrategys.add(actStrategy);
		}

		// Tł̂ݗps
		if( gameInfo.getRole() == Role.WEREWOLF ){
			actStrategy = new HasActionStrategy(new VoteStack(), 3.0);
			actionStrategys.add(actStrategy);
			actStrategy = new HasActionStrategy(new AttackObstacle(), 1.0);
			actionStrategys.add(actStrategy);
			actStrategy = new HasActionStrategy(new PowerPlay_Werewolf(), 1.0);
			actionStrategys.add(actStrategy);
		}

		// lł̂ݗps
		if( gameInfo.getRole() == Role.POSSESSED ){
			actStrategy = new HasActionStrategy(new PowerPlay_Possessed(), 1.0);
			actionStrategys.add(actStrategy);
		}

	}


	@Override
	public void dayStart() {
		// sݒZbg
		actionUI.reset();
		planningVoteAgent = null;
		declaredPlanningVoteAgent = null;
	}


	@Override
	public void update(GameInfo gameInfo) {

		try{

			// ԌvJn
			long starttime = System.currentTimeMillis();

			super.update(gameInfo);

			// gQ[̍XV
			agi.update(gameInfo);

			// tXVȊOɐns
			if( !agi.isDayUpdate() ){

				// s
				execGuess();

				// s\
				execActionReserve();

			}

			// ԌvI
			long endtime = System.currentTimeMillis();
			long updatetime = endtime - starttime;

			// update()̏ԂŒȂL
			if( updatetime > MaxUpdateTime ){
				MaxUpdateTime = updatetime;
				MaxUpdateTiming = new StringBuilder().append(getDay()).append(" ").append(gameInfo.getTalkList().size()).append("").toString();
			}

		}catch(Exception ex){
			// Do Nothing
		}finally{
			// Do Nothing
		}

	}


	@Override
	public Agent attack() {

		// 点
		if( isPrintPassageTalk ){
			putDebugMessage(actionUI.attackAgent.toString() + "P");
		}

		if( actionUI.attackAgent == null ){
			return null;
		}
		return Agent.getAgent(actionUI.attackAgent);
	}


	@Override
	public Agent vote() {
		if( actionUI.voteAgent == null ){
			// [錾oĂȂꍇA[悤ƎvĂ҂ɓ[
			if( planningVoteAgent == null ){
				return null;
			}
			return Agent.getAgent(planningVoteAgent);
		}
		return Agent.getAgent(actionUI.voteAgent);
	}


	@Override
	public Agent guard() {
		if( actionUI.guardAgent == null ){
			return null;
		}
		return Agent.getAgent(actionUI.guardAgent);
	}


	@Override
	public Agent divine() {
		if( actionUI.inspectAgent == null ){
			return null;
		}
		return Agent.getAgent(actionUI.inspectAgent);
	}


	@Override
	public String whisper(){
		return null;
	}


	@Override
	public void finish() {

		// Ȉ𒝂点邩
		if( isPrintFinishTalk ){
			// 点i܂j

			GameInfo gameInfo = agi.latestGameInfo;
			ArrayList<Integer> wolves = new ArrayList<Integer>();
			ArrayList<Integer> possess = new ArrayList<Integer>();
			for( int i = 1; i<= agi.gameSetting.getPlayerNum(); i++ ){
				Role role = gameInfo.getRoleMap().get( Agent.getAgent(i) );
				if( role == Role.WEREWOLF ){
					wolves.add(i);
				}else if( role == Role.POSSESSED ){
					possess.add(i);
				}
			}
			WolfsidePattern dummyWolfside = new WolfsidePattern( wolves ,possess );
			InspectedWolfsidePattern dummyInspect = latestGuess.getPattern(dummyWolfside);
			if( dummyInspect != null ){
				double dummyWolfsideScore = latestGuess.getPattern(dummyWolfside).score;
				putDebugMessage("ۂ̓ " + dummyWolfside.toString() + String.format(" (Score:%.5f) ", dummyWolfsideScore));
			}


			WolfsidePattern mostValidWolfside = latestGuess.getMostValidPattern().pattern;
			double mostValidWolfsideScore = latestGuess.getMostValidPattern().score;
			putDebugMessage("ŏI " + mostValidWolfside.toString() + String.format(" (Score:%.5f) ", mostValidWolfsideScore));

			// fobObZ[W̏o
			putDebugMessage("update() ŒԂ" + MaxUpdateTime + "ms (" + MaxUpdateTiming + ")");
		}

		// wKf[^̍XV
		updateLearnData();


		//TODO t@Co͂͑ŋ֎~Ȃ̂ŁA킵Ȃ悤RgAEgĂBgƂ͖߂
//		// wKpf[^̏o
//		if( isPutLearnData ){
//			putLeaningData();
//		}

	}


	/**
	 * s
	 */
	protected void execGuess(){

		GameInfo gameInfo = agi.latestGameInfo;

		GuessManager guessManager = new GuessManager(agi.gameSetting.getPlayerNum());
		ArrayList<Guess> guesses;

		// 헪ւ̈̐ݒ
		GuessStrategyArgs args = new GuessStrategyArgs();
		args.agi = agi;
		args.agentParam = agentParam;

		// e헪NX琄擾
		for( HasGuessStrategy hasStrategy : guessStrategys ){
			guesses = hasStrategy.strategy.getGuessList(args);
			guessManager.addGuess(ReceivedGuess.newGuesses(guesses, hasStrategy.strategy));
		}

		// ̐番͌ʂ擾
		AnalysisOfGuess aguess = new AnalysisOfGuess(agi.gameSetting.getPlayerNum()  , agi.selfViewInfo.wolfsidePatterns, guessManager);

		// ŐV̐ƂĊi[
		latestGuess = aguess;

		// 点
		if( isPrintPassageTalk ){
			WolfsidePattern mostValidWolfside = aguess.getMostValidPattern().pattern;
			putDebugMessage(mostValidWolfside.toString() + " ", gameInfo.getDay(), gameInfo.getTalkList().size());
		}

	}


	/**
	 * s\s
	 */
	protected void execActionReserve(){

		RequestManager ReqManager = new RequestManager();

		// s헪ւ̈̐ݒ
		ActionStrategyArgs args = new ActionStrategyArgs();
		args.agi = agi;
		args.view = agi.selfViewInfo;
		args.aguess = latestGuess;
		args.parsonalData = agentParam;

		// es헪NXsv擾
		for( HasActionStrategy hasStrategy : actionStrategys ){
			ArrayList<Request> Requests = hasStrategy.strategy.getRequests(args);
			ReqManager.addRequest(ReceivedRequest.newRequests(Requests, hasStrategy.strategy));
		}

		// svWvA擾
		AnalysisOfRequest calcRequest = new AnalysisOfRequest(agi.gameSetting.getPlayerNum(), ReqManager.allRequest);


		// es̑ΏۂƂčłÓȐl擾
		int voteAgentNo = calcRequest.getMaxVoteRequest().agentNo;
		int guardAgentNo = calcRequest.getMaxGuardRequest().agentNo;
		int inspectAgentNo = calcRequest.getMaxInspectRequest().agentNo;
		int attackAgentNo = calcRequest.getMaxAttackRequest().agentNo;

		// [\ƂċLiۂ̓[Zbg͓[錾ɍsj
		planningVoteAgent = voteAgentNo;

		// [ȊO̊esZbg
		actionUI.guardAgent = guardAgentNo;
		actionUI.inspectAgent = inspectAgentNo;
		actionUI.attackAgent = attackAgentNo;

		// ŐV̍svƂĊi[
		latestRequest = calcRequest;

	}


	/**
	 * COKv̔fs
	 * @return
	 */
	protected boolean isAvoidance(){

		GameInfo gameInfo = agi.latestGameInfo;

		// [錾ς݃G[WFg̐
		int voteAgentCount = 0;

		// G[WFg̓[\擾
		Integer[] voteTarget = new Integer[agi.gameSetting.getPlayerNum() + 1];
		for( Agent agent : gameInfo.getAliveAgentList() ){
			voteTarget[agent.getAgentIdx()] = agi.getSaidVoteAgent(agent.getAgentIdx());

			// [錾ς݃G[WFg̃JEg
			if( voteTarget[agent.getAgentIdx()] != null ){
				voteAgentCount++;
			}
		}

		// G[WFg̔퓊[擾
		int[] voteReceiveNum = new int[agi.gameSetting.getPlayerNum() + 1];
		for( int i = 1; i < voteTarget.length; i++ ){
			if( voteTarget[i] != null ){
				voteReceiveNum[voteTarget[i]]++;
			}
		}

		// ő[̃G[WFg̕[擾
		int maxVoteCount = 0;
		for( int i = 1; i < voteTarget.length; i++ ){
			if( voteReceiveNum[i] > maxVoteCount ){
				maxVoteCount = voteReceiveNum[i];
			}
		}


		// ݂肪Ȃ͉CO̕KvȂ
		if( gameInfo.getDay() < 1 ){
			return false;
		}

		// 3ڂ܂ł͉COȂ(܂ŎOverԂȂ悤ɂ邱)
		if( agi.getMyTalkNum() < 2 ){
			return false;
		}

		// [錾҂ȂΉCO̕KvȂ
		if( voteAgentCount < gameInfo.getAliveAgentList().size() * 0.65 ){
			return false;
		}

		// ő[𓾂ĂΉCOKv
		if( voteReceiveNum[gameInfo.getAgent().getAgentIdx()] >= maxVoteCount ){
			return true;
		}

		return false;

	}


	/**
	 * ^b͂擾(b̕ۑs)
	 * @return
	 */
	protected String getSuspicionTalkString(){

		// ^ׂl擾
		Integer suspicionAgentNo = getSuspicionTalkAgentNo();

		// ^ׂlΘb
		if( suspicionAgentNo != null ){
			//TODO LɎ̔ǂĎ擾݌vvzƂĂ͗ǂ
			// ^ςƂċL
			agi.talkedSuspicionAgentList.add(suspicionAgentNo);

			// eԂ
			String ret = TemplateTalkFactory.estimate( Agent.getAgent(suspicionAgentNo), Role.WEREWOLF );
			return ret;
		}

		// ̔sȂꍇAnullԂ
		return null;

	}


	/**
	 * Mpb͂擾(b̕ۑs)
	 * @return
	 */
	protected String getTrustTalkString(){

		// ŐV͌̕ʂ擾
		AnalysisOfGuess aguess = latestGuess;

		// łÓȘTwc̃XRA擾
		double mostValidWolfsideScore = aguess.getMostValidPattern().score;

		// ̑SG[WFg𑖍
		for( Agent agent : agi.latestGameInfo.getAliveAgentList() ){

			// ̓XLbv
			if( agent.equals(getMe()) ){
				continue;
			}

			int agentNo = agent.getAgentIdx();

			InspectedWolfsidePattern wolfPattern = aguess.getMostValidWolfPattern(agentNo);
			InspectedWolfsidePattern posPattern = aguess.getMostValidPossessedPattern(agentNo);

			double wolfScore = 0.0;
			double posScore = 0.0;
			if( wolfPattern != null ){
				wolfScore = wolfPattern.score;
			}
			if( posPattern != null ){
				posScore = posPattern.score;
			}

			// TElꂼ̍őXRA
			if( wolfScore < mostValidWolfsideScore * 0.8 &&
			    posScore < mostValidWolfsideScore * 0.8 ){

				if( !agi.talkedTrustAgentList.contains(agentNo) ){

					// MpςƂċL
					agi.talkedTrustAgentList.add(agentNo);

					Role role;

					// COĂ邩
					if( agi.agentState[agentNo].comingOutRole != null ){
						// COEƐ
						role = agi.agentState[agentNo].comingOutRole;
					}else{
						// lƐ
						role = Role.VILLAGER;
					}

					// eԂ
					String ret = TemplateTalkFactory.estimate(agent, role);
					return ret;
				}
			}

		}

		// ̔sȂꍇAnullԂ
		return null;

	}


	/**
	 * ^ƂĘbׂG[WFgԍ擾
	 * @return G[WFgԍ(Null̏ꍇL)
	 */
	protected Integer getSuspicionTalkAgentNo(){

		// ŐV͌̕ʂ擾
		AnalysisOfGuess aguess = latestGuess;

		// łÓȘTwc擾
		WolfsidePattern mostValidWolfside = aguess.getMostValidPattern().pattern;

		// ^ƂĔĂȂT擾
		ArrayList<Integer> wolves = new ArrayList<Integer>();
		for( Integer wolf : mostValidWolfside.wolfAgentNo ){
			if( !agi.talkedSuspicionAgentList.contains(wolf) ){
				wolves.add(wolf);
			}
		}

		// ΏەsݎNullԂ
		if( wolves.isEmpty() ){
			return null;
		}

		return wolves.get(0);

	}


	/**
	 * wKf[^̍XV
	 */
 	protected void updateLearnData(){

		GameInfo gameInfo = agi.latestGameInfo;
		WolfsidePattern lastGuessWolfPattern = latestGuess.getMostValidPattern().pattern;

		// Q[+1
		LearnData.gameCount += 1;

		// HJEg
		switch( agi.agentState[gameInfo.getAgent().getAgentIdx()].causeofDeath ){
			case ALIVE:
				LearnData.aliveCount++;
				break;
			case ATTACKED:
				LearnData.attackCount++;
				break;
			case EXECUTED:
				LearnData.executeCount++;
				break;
			default:
				break;
		}

		// T𐔂̃JEg
		int wolfCorrectCount = 0;
		for( int wolf : lastGuessWolfPattern.wolfAgentNo ){
			if( gameInfo.getRoleMap().get(Agent.getAgent(wolf)) == Role.WEREWOLF ){
				wolfCorrectCount++;
			}
		}
		LearnData.wolfCorrectCount[wolfCorrectCount]++;

		// update()̏ԂŒȂL
		if( MaxUpdateTime > LearnData.maxUpdateTime ){
			LearnData.maxUpdateTime = MaxUpdateTime;
		}
	}


//TODO t@Co͂͑ŋ֎~Ȃ̂ŁA킵Ȃ悤RgAEgĂBgƂ͖߂
//	/**
//	 * wKpf[^̏o
//	 */
//	protected void putLeaningData(){
//
//		// vpf[^̏o
//		try{
//
//			File file = new File("C:\\Temp\\aiwolf_leaning\\hogehoge.csv");
//			FileOutputStream fos = new FileOutputStream(file,true);
//			OutputStreamWriter osw = new OutputStreamWriter(fos);
//			PrintWriter pw = new PrintWriter(osw);
//
//			pw.print("");
//
//			pw.println();
//
//			pw.close();
//
//		}catch(IOException e){
//			System.out.println(e);
//		}
//
//	}


	/**
	 * fobObZ[W𒝂点܂
	 * @param str
	 * @param day
	 * @param talkid
	 */
	protected void putDebugMessage(String str){

		GameInfo gameInfo = agi.latestGameInfo;

		System.out.println("(Agent" + gameInfo.getAgent().getAgentIdx() + ") "
		                   + " "
		                   + str
		                   + "");

	}


	/**
	 * fobObZ[W𒝂点܂
	 * @param str
	 * @param day
	 * @param talkid
	 */
	protected void putDebugMessage(String str, int day, int talkid){

		GameInfo gameInfo = agi.latestGameInfo;

		System.out.println("(Agent" + gameInfo.getAgent().getAgentIdx() + ") "
		                   + " "
		                   + "(" + day + " " + talkid + ") "
		                   + str
		                   + "");

	}


}
